/**************************
***** Compiler Parameters *****
***************************
@P EffectName: DW_ForwardShader
@P   - Material.PixelStageSurfaceShaders: mixin MaterialSurfaceArray [{layers = [mixin MaterialSurfaceDiffuse [{diffuseMap = ComputeColorTextureScaledOffsetDynamicSampler<Material.DiffuseMap,TEXCOORD0,Material.Sampler.i0,rgba,Material.TextureScale,Material.TextureOffset>}], mixin MaterialSurfaceNormalMap<true,true> [{normalMap = ComputeColorTextureScaledOffsetDynamicSampler<Material.NormalMap,TEXCOORD0,Material.Sampler.i0,rgba,Material.TextureScale.i1,Material.TextureOffset.i1>}], mixin MaterialSurfaceGlossinessMap<false> [{glossinessMap = ComputeColorTextureScaledOffsetDynamicSampler<Material.GlossinessMap,TEXCOORD0,Material.Sampler.i0,g,Material.TextureScale.i2,Material.TextureOffset.i2>}], mixin MaterialSurfaceSetStreamFromComputeColor<matSpecular,rgb> [{computeColorSource = ComputeColorConstantColorLink<Material.SpecularValue>}], mixin MaterialSurfaceSetStreamFromComputeColor<matSpecularIntensity,r> [{computeColorSource = ComputeColorConstantFloatLink<Material.SpecularIntensityValue>}], mixin MaterialSurfaceSetStreamFromComputeColor<matAmbientOcclusion,r> [{computeColorSource = ComputeColorTextureScaledOffsetDynamicSampler<Material.AmbientOcclusionMap,TEXCOORD0,Material.Sampler.i0,b,Material.TextureScale.i3,Material.TextureOffset.i3>}], mixin MaterialSurfaceSetStreamFromComputeColor<matAmbientOcclusionDirectLightingFactor,r> [{computeColorSource = ComputeColorConstantFloatLink<Material.AmbientOcclusionDirectLightingFactorValue>}], mixin MaterialSurfaceSetStreamFromComputeColor<matCavity,r> [{computeColorSource = ComputeColorConstantFloatLink<Material.CavityValue>}], mixin MaterialSurfaceSetStreamFromComputeColor<matCavityDiffuse,r> [{computeColorSource = ComputeColorConstantFloatLink<Material.CavityDiffuseValue>}], mixin MaterialSurfaceSetStreamFromComputeColor<matCavitySpecular,r> [{computeColorSource = ComputeColorConstantFloatLink<Material.CavitySpecularValue>}], mixin MaterialSurfaceSetStreamFromComputeColor<matEmissive,rgba> [{computeColorSource = ComputeColorTextureScaledOffsetDynamicSampler<Material.EmissiveMap,TEXCOORD0,Material.Sampler.i0,rgba,Material.TextureScale.i4,Material.TextureOffset.i4>}], mixin MaterialSurfaceSetStreamFromComputeColor<matEmissiveIntensity,r> [{computeColorSource = ComputeColorConstantFloatLink<Material.EmissiveIntensity>}], mixin MaterialSurfaceLightingAndShading [{surfaces = [MaterialSurfaceShadingDiffuseLambert<true>, mixin MaterialSurfaceShadingSpecularMicrofacet [{environmentFunction = MaterialSpecularMicrofacetEnvironmentGGXLUT}, {fresnelFunction = MaterialSpecularMicrofacetFresnelSchlick}, {geometricShadowingFunction = MaterialSpecularMicrofacetVisibilityImplicit}, {normalDistributionFunction = MaterialSpecularMicrofacetNormalDistributionBlinnPhong}]]}], MaterialSurfaceEmissiveShading<false>]}]
@P Material.PixelStageStreamInitializer: mixin MaterialStream, MaterialPixelShadingStream
@P Material.HasNormalMap: True
@P Lighting.DirectLightGroups: LightClusteredPointGroup, LightClusteredSpotGroup
@P Lighting.EnvironmentLights: LightSimpleAmbient, xkfx LightSkyboxEffect
@P LightSkyboxShader.LightDiffuseColor.environmentLights[1]: SphericalHarmonicsEnvironmentColor<5>
@P LightSkyboxShader.LightSpecularColor.environmentLights[1]: RoughnessCubeMapEnvironmentColor
@P XenkoEffectBase.RenderTargetExtensions: mixin
***************************
****  ConstantBuffers  ****
***************************
cbuffer PerDraw [Size: 512]
@C    World_id31 => Transformation.World
@C    WorldInverse_id32 => Transformation.WorldInverse
@C    WorldInverseTranspose_id33 => Transformation.WorldInverseTranspose
@C    WorldView_id34 => Transformation.WorldView
@C    WorldViewInverse_id35 => Transformation.WorldViewInverse
@C    WorldViewProjection_id36 => Transformation.WorldViewProjection
@C    WorldScale_id37 => Transformation.WorldScale
@C    EyeMS_id38 => Transformation.EyeMS
@C    DW_NoiseOffset_id96 => DamageOverlay.DW_NoiseOffset
@C    DW_NoiseScale_id97 => DamageOverlay.DW_NoiseScale
@C    DW_DamageLevel_id98 => DamageOverlay.DW_DamageLevel
@C    DW_NoiseOffsetFactor_id99 => DamageOverlay.DW_NoiseOffsetFactor
@C    DW_ConstructionLevel_id100 => DamageOverlay.DW_ConstructionLevel
@C    DW_TimeValue_id101 => DamageOverlay.DW_TimeValue
@C    DW_NoiseColorLow_id102 => DamageOverlay.DW_NoiseColorLow
@C    DW_NoiseColorLowAdd_id103 => DamageOverlay.DW_NoiseColorLowAdd
@C    DW_NoiseColorHigh_id104 => DamageOverlay.DW_NoiseColorHigh
@C    DW_NoiseColorHighAdd_id105 => DamageOverlay.DW_NoiseColorHighAdd
cbuffer PerMaterial [Size: 128]
@C    scale_id196 => Material.TextureScale
@C    offset_id197 => Material.TextureOffset
@C    scale_id201 => Material.TextureScale.i1
@C    offset_id202 => Material.TextureOffset.i1
@C    scale_id208 => Material.TextureScale.i2
@C    offset_id209 => Material.TextureOffset.i2
@C    constantColor_id215 => Material.SpecularValue
@C    constantFloat_id217 => Material.SpecularIntensityValue
@C    scale_id221 => Material.TextureScale.i3
@C    offset_id222 => Material.TextureOffset.i3
@C    constantFloat_id224 => Material.AmbientOcclusionDirectLightingFactorValue
@C    constantFloat_id226 => Material.CavityValue
@C    constantFloat_id228 => Material.CavityDiffuseValue
@C    constantFloat_id230 => Material.CavitySpecularValue
@C    scale_id234 => Material.TextureScale.i4
@C    offset_id235 => Material.TextureOffset.i4
@C    constantFloat_id237 => Material.EmissiveIntensity
cbuffer PerView [Size: 928]
@C    View_id24 => Transformation.View
@C    ViewInverse_id25 => Transformation.ViewInverse
@C    Projection_id26 => Transformation.Projection
@C    ProjectionInverse_id27 => Transformation.ProjectionInverse
@C    ViewProjection_id28 => Transformation.ViewProjection
@C    ProjScreenRay_id29 => Transformation.ProjScreenRay
@C    Eye_id30 => Transformation.Eye
@C    NearClipPlane_id109 => Camera.NearClipPlane
@C    FarClipPlane_id110 => Camera.FarClipPlane
@C    ZProjection_id111 => Camera.ZProjection
@C    ViewSize_id112 => Camera.ViewSize
@C    AspectRatio_id113 => Camera.AspectRatio
@C    _padding_PerView_Default => _padding_PerView_Default
@C    ClusterDepthScale_id118 => LightClustered.ClusterDepthScale
@C    ClusterDepthBias_id119 => LightClustered.ClusterDepthBias
@C    ClusterStride_id120 => LightClustered.ClusterStride
@C    AmbientLight_id123 => LightSimpleAmbient.AmbientLight.environmentLights[0]
@C    SphericalColors_id128 => SphericalHarmonicsEnvironmentColor.SphericalColors.lightDiffuseColor.environmentLights[1]
@C    MipCount_id187 => RoughnessCubeMapEnvironmentColor.MipCount.lightSpecularColor.environmentLights[1]
@C    SkyMatrix_id189 => LightSkyboxShader.SkyMatrix.environmentLights[1]
@C    Intensity_id190 => LightSkyboxShader.Intensity.environmentLights[1]
@C    _padding_PerView_Lighting => _padding_PerView_Lighting
***************************
******  Resources    ******
***************************
@R    PerMaterial => PerMaterial [Stage: None, Slot: (-1--1)]
@R    Texture_id193 => Material.DiffuseMap [Stage: None, Slot: (-1--1)]
@R    Texture_id193 => Material.DiffuseMap [Stage: None, Slot: (-1--1)]
@R    Sampler_id194 => Material.Sampler.i0 [Stage: None, Slot: (-1--1)]
@R    Sampler_id194 => Material.Sampler.i0 [Stage: None, Slot: (-1--1)]
@R    Texture_id199 => Material.NormalMap [Stage: None, Slot: (-1--1)]
@R    Texture_id199 => Material.NormalMap [Stage: None, Slot: (-1--1)]
@R    Texture_id206 => Material.GlossinessMap [Stage: None, Slot: (-1--1)]
@R    Texture_id206 => Material.GlossinessMap [Stage: None, Slot: (-1--1)]
@R    Texture_id219 => Material.AmbientOcclusionMap [Stage: None, Slot: (-1--1)]
@R    Texture_id219 => Material.AmbientOcclusionMap [Stage: None, Slot: (-1--1)]
@R    Texture_id232 => Material.EmissiveMap [Stage: None, Slot: (-1--1)]
@R    Texture_id232 => Material.EmissiveMap [Stage: None, Slot: (-1--1)]
@R    EnvironmentLightingDFG_LUT_id244 => MaterialSpecularMicrofacetEnvironmentGGXLUT.EnvironmentLightingDFG_LUT [Stage: None, Slot: (-1--1)]
@R    EnvironmentLightingDFG_LUT_id244 => MaterialSpecularMicrofacetEnvironmentGGXLUT.EnvironmentLightingDFG_LUT [Stage: None, Slot: (-1--1)]
@R    LightClusters_id116 => LightClustered.LightClusters [Stage: None, Slot: (-1--1)]
@R    LightClusters_id116 => LightClustered.LightClusters [Stage: None, Slot: (-1--1)]
@R    LightIndices_id117 => LightClustered.LightIndices [Stage: None, Slot: (-1--1)]
@R    LightIndices_id117 => LightClustered.LightIndices [Stage: None, Slot: (-1--1)]
@R    PointLights_id121 => LightClusteredPointGroup.PointLights [Stage: None, Slot: (-1--1)]
@R    PointLights_id121 => LightClusteredPointGroup.PointLights [Stage: None, Slot: (-1--1)]
@R    SpotLights_id122 => LightClusteredSpotGroup.SpotLights [Stage: None, Slot: (-1--1)]
@R    SpotLights_id122 => LightClusteredSpotGroup.SpotLights [Stage: None, Slot: (-1--1)]
@R    CubeMap_id188 => RoughnessCubeMapEnvironmentColor.CubeMap.lightSpecularColor.environmentLights[1] [Stage: None, Slot: (-1--1)]
@R    CubeMap_id188 => RoughnessCubeMapEnvironmentColor.CubeMap.lightSpecularColor.environmentLights[1] [Stage: None, Slot: (-1--1)]
@R    PerDraw => PerDraw [Stage: Vertex, Slot: (0-0)]
@R    PerView => PerView [Stage: Vertex, Slot: (1-1)]
@R    NoiseTextureCoarse3DSampler_id85 => NoiseFunctions.NoiseTextureCoarse3DSampler [Stage: Pixel, Slot: (0-0)]
@R    LinearSampler_id159 => Texturing.LinearSampler [Stage: Pixel, Slot: (1-1)]
@R    Sampler_id194 => Material.Sampler.i0 [Stage: Pixel, Slot: (2-2)]
@R    NoiseTextureCoarse3D_id84 => NoiseFunctions.NoiseTextureCoarse3D [Stage: Pixel, Slot: (0-0)]
@R    Texture_id193 => Material.DiffuseMap [Stage: Pixel, Slot: (1-1)]
@R    Texture_id199 => Material.NormalMap [Stage: Pixel, Slot: (2-2)]
@R    Texture_id206 => Material.GlossinessMap [Stage: Pixel, Slot: (3-3)]
@R    Texture_id219 => Material.AmbientOcclusionMap [Stage: Pixel, Slot: (4-4)]
@R    Texture_id232 => Material.EmissiveMap [Stage: Pixel, Slot: (5-5)]
@R    EnvironmentLightingDFG_LUT_id244 => MaterialSpecularMicrofacetEnvironmentGGXLUT.EnvironmentLightingDFG_LUT [Stage: Pixel, Slot: (6-6)]
@R    LightClusters_id116 => LightClustered.LightClusters [Stage: Pixel, Slot: (7-7)]
@R    LightIndices_id117 => LightClustered.LightIndices [Stage: Pixel, Slot: (8-8)]
@R    PointLights_id121 => LightClusteredPointGroup.PointLights [Stage: Pixel, Slot: (9-9)]
@R    SpotLights_id122 => LightClusteredSpotGroup.SpotLights [Stage: Pixel, Slot: (10-10)]
@R    CubeMap_id188 => RoughnessCubeMapEnvironmentColor.CubeMap.lightSpecularColor.environmentLights[1] [Stage: Pixel, Slot: (11-11)]
@R    PerDraw => PerDraw [Stage: Pixel, Slot: (0-0)]
@R    PerMaterial => PerMaterial [Stage: Pixel, Slot: (1-1)]
@R    PerView => PerView [Stage: Pixel, Slot: (2-2)]
***************************
*****     Sources     *****
***************************
@S    ShaderBase => acbe3d4d44a046eede871176bee9c754
@S    ShaderBaseStream => a3a5bf8185f2a3d89972293f806430d3
@S    ShadingBase => a56c21640e78c756e8d56651480eb9f5
@S    ComputeColor => ded06879812e042b84d284d2272e4b4a
@S    TransformationBase => be8628f6067b518dd5c7b3fe338b9320
@S    NormalStream => b59c6ee174b93be981cc113a7a70d70b
@S    TransformationWAndVP => 37eaa3c16c9e83fd77e04c47c6794803
@S    PositionStream4 => b1f2243b30eb87e6e40bc6af56b4fd18
@S    PositionHStream4 => 0c0bb9059a8e3199d9ec950f3a7d2b66
@S    Transformation => ce8c4a6980d1f949f5f9aed15679c96d
@S    NormalFromNormalMapping => 315b586b02274b1052250b632979afa4
@S    NormalBase => 118edc0075e4c3a87c3cb4570a808039
@S    NormalUpdate => 9bf3758fe45b1105750554fed463a15e
@S    MaterialSurfacePixelStageCompositor => cb7b21ca902e1b289c9d765318058f5a
@S    PositionStream => d767885dace5d697c6532bb4f0f5b3f8
@S    MaterialPixelShadingStream => ce423644e4da2371ef9e6b451c39edf7
@S    MaterialPixelStream => 83c4d63f50d89eb133457f26bcc25822
@S    MaterialStream => f4c30b25d4f10a4a3809b97598bfca17
@S    IStreamInitializer => 37d0ab08af9e2896a54aa43c0ea2ad0f
@S    LightStream => 622a7adc4e53980a3d0e0fecffc76661
@S    DirectLightGroupArray => b6017f14fd58343b7a54fefa2ca81610
@S    DirectLightGroup => 08ae1198dfb5788ff8584d747c3b8368
@S    ShadowGroup => 05cfb339de033879838a6606f047a866
@S    ShadowStream => 38650f3182fa7d3cab3bae43f9398f4e
@S    TextureProjectionGroup => 47f8334211d8d5ae6d98f32a923759cc
@S    EnvironmentLightArray => 4129555ea2051a98f5cf5e315d791d3e
@S    EnvironmentLight => 6aceaad54f2057382904d7f6dfa58e4f
@S    IMaterialSurface => d56637e1116951bd72b1817daa1a6158
@S    CommonFunctions => c74d74b28168c2ce34652455914178d9
@S    NoiseFunctions => f2b7f59cae0e3f7d048e30a560e67073
@S    DamageOverlay => 8f0c2f0b88557c66f1d070c286889753
@S    LightClusteredPointGroup => c5703508c16a19f7acb9ebe6676eeb4a
@S    LightClustered => 82f6bcf6878ecb8f1cf19364969848f1
@S    ScreenPositionBase => b66b925e44d5cef758dd09d560d88680
@S    Camera => 38d8cc7176ac62fc4d9c97d70f9013ab
@S    LightPoint => 5cc6bc739ab0f656d8a48332e8ca569b
@S    LightUtil => 2587d00dc291bbace485f1420ae464ad
@S    LightClusteredSpotGroup => d9e6bd2fe470894c4d8bebba13305bf2
@S    LightSpot => ff13b9737bc99d2458fa5aa679b6b8f0
@S    SpotLightDataInternalShader => 4c9afecddd31668dbea2f90869a2d5f0
@S    LightSpotAttenuationDefault => a424c87e1fb86625b52e4ab0ab01bf46
@S    LightSimpleAmbient => 5216c2bc901f0543bc29393671a09451
@S    LightSkyboxShader => 82f50e49ee33fe5de0a04d94a2fc07f8
@S    IComputeEnvironmentColor => ec85adeba938ee8d9397a3905bce223e
@S    SphericalHarmonicsEnvironmentColor => 1517de2611b98588343bca5614e4be9d
@S    SphericalHarmonicsUtils => ac3b096f31df8f2c6f118c8a0852de50
@S    Math => 49d7f7706890095f248caeaf232f4db4
@S    RoughnessCubeMapEnvironmentColor => c1bc2e6a76a07d2b72e155ed7a35c643
@S    Texturing => e6daef0dd90a55f9549c6f5d291e61a5
@S    MaterialSurfaceArray => ca7a8b492198ae093d4f490c2ba6aaec
@S    MaterialSurfaceDiffuse => c60d7ca8058e062fcba77cc9b4c7d496
@S    IMaterialSurfacePixel => b5f583c7b871b6a4ebe5c7411883503e
@S    ComputeColorTextureScaledOffsetDynamicSampler => 680e61052fd580928ba07d61381cf7aa
@S    DynamicTexture => c9a2e65d8e419b069971342ac1eaffe1
@S    DynamicSampler => c7e36b002252e5b947f67278b28b0957
@S    DynamicTextureStream => 49c11eb479810dd1fa94c1639e04e5cf
@S    MaterialSurfaceNormalMap => 2bd2b6237de389138cd85d059531fb91
@S    MaterialSurfaceGlossinessMap => d7edef2f457bc2e68a2644819057820d
@S    MaterialSurfaceSetStreamFromComputeColor => c2d77b2aa35d9f24b852eb4a5fdc9872
@S    IMaterialSurfaceVertex => 0c5c73d45a721c87c347ae02954665ce
@S    MaterialVertexStream => 88c18bd25810bbb05cdd7c08ebc8c4a2
@S    MaterialDisplacementStream => 2f1b0f776096589363e85354152ef62e
@S    IMaterialSurfaceDomain => f21c77ffcac748537e778154fecb0921
@S    MaterialDomainStream => cf19dcc996d2d1de16031ccad6eafac0
@S    MaterialTessellationStream => fc291f489bf9de3c2dd85f2960efacc9
@S    ComputeColorConstantColorLink => a30d6cd76f7c0875cdeffdb3ae8bae33
@S    ComputeColorConstantFloatLink => 12410f8b57e4015ff1a3fce241440b62
@S    MaterialSurfaceLightingAndShading => 68ac8c9f25624fdc15ea262fbc868030
@S    IMaterialSurfaceShading => 43b5938a14c30cfc19b2ddcb76824cbe
@S    MaterialSurfaceShadingDiffuseLambert => ebe9647a0e11903ef16a793ffdbdd34c
@S    MaterialSurfaceShadingSpecularMicrofacet => d73b976ae539136e12c8ad3b9c23fde4
@S    BRDFMicrofacet => 7e71ebf42695365a986502c8c568bd4c
@S    IMaterialSpecularMicrofacetFresnelFunction => 202cfaa696414bc80515f7cc9128dba0
@S    IMaterialSpecularMicrofacetVisibilityFunction => 3426c6d9f0a56bcb6863f3537df6b8dd
@S    IMaterialSpecularMicrofacetNormalDistributionFunction => b91eb150f041a287afbd1a1317f3218b
@S    IMaterialSpecularMicrofacetEnvironmentFunction => 6fe5dc0428d341b5128f0268a3b15d6e
@S    MaterialSpecularMicrofacetEnvironmentGGXLUT => 1d429af3e4e1cf62dbc90503fc7cf2bd
@S    MaterialSpecularMicrofacetFresnelSchlick => 7c4f716bc4013816bc7dfd0875fe37c0
@S    MaterialSpecularMicrofacetVisibilityImplicit => 44e4d45b736d452236dd6b177606ac05
@S    MaterialSpecularMicrofacetNormalDistributionBlinnPhong => 61e73cf68bf66972ee994d8f05b01f02
@S    MaterialSurfaceEmissiveShading => 013ca1293b7b72150881283c25b3c88c
***************************
*****     Stages      *****
***************************
@G    Vertex => db3e1b55b6224af7d37165c26ce1216b
//
// Generated by Microsoft (R) HLSL Shader Compiler 10.1
//
//
// Buffer Definitions: 
//
// cbuffer PerDraw
// {
//
//   float4x4 World_id31;               // Offset:    0 Size:    64
//   float4x4 WorldInverse_id32;        // Offset:   64 Size:    64 [unused]
//   float4x4 WorldInverseTranspose_id33;// Offset:  128 Size:    64 [unused]
//   float4x4 WorldView_id34;           // Offset:  192 Size:    64 [unused]
//   float4x4 WorldViewInverse_id35;    // Offset:  256 Size:    64 [unused]
//   float4x4 WorldViewProjection_id36; // Offset:  320 Size:    64 [unused]
//   float3 WorldScale_id37;            // Offset:  384 Size:    12 [unused]
//   float4 EyeMS_id38;                 // Offset:  400 Size:    16 [unused]
//   float3 DW_NoiseOffset_id96;        // Offset:  416 Size:    12 [unused]
//      = 0x00000000 0x00000000 0x00000000 
//   float DW_NoiseScale_id97;          // Offset:  428 Size:     4 [unused]
//      = 0x41200000 
//   float DW_DamageLevel_id98;         // Offset:  432 Size:     4 [unused]
//      = 0x00000000 
//   float DW_NoiseOffsetFactor_id99;   // Offset:  436 Size:     4 [unused]
//      = 0x3f800000 
//   float DW_ConstructionLevel_id100;  // Offset:  440 Size:     4 [unused]
//      = 0x3f800000 
//   float DW_TimeValue_id101;          // Offset:  444 Size:     4 [unused]
//   float4 DW_NoiseColorLow_id102;     // Offset:  448 Size:    16 [unused]
//      = 0x3f000000 0x00000000 0x00000000 0x3f800000 
//   float4 DW_NoiseColorLowAdd_id103;  // Offset:  464 Size:    16 [unused]
//      = 0x3f99999a 0x3f19999a 0x00000000 0x3f800000 
//   float4 DW_NoiseColorHigh_id104;    // Offset:  480 Size:    16 [unused]
//      = 0x3f800000 0x3f800000 0x00000000 0x3f800000 
//   float4 DW_NoiseColorHighAdd_id105; // Offset:  496 Size:    16 [unused]
//      = 0x40333333 0x40000000 0x3ff33333 0x3f800000 
//
// }
//
// cbuffer PerView
// {
//
//   float4x4 View_id24;                // Offset:    0 Size:    64 [unused]
//   float4x4 ViewInverse_id25;         // Offset:   64 Size:    64 [unused]
//   float4x4 Projection_id26;          // Offset:  128 Size:    64 [unused]
//   float4x4 ProjectionInverse_id27;   // Offset:  192 Size:    64 [unused]
//   float4x4 ViewProjection_id28;      // Offset:  256 Size:    64
//   float2 ProjScreenRay_id29;         // Offset:  320 Size:     8 [unused]
//   float4 Eye_id30;                   // Offset:  336 Size:    16 [unused]
//   float NearClipPlane_id109;         // Offset:  352 Size:     4 [unused]
//      = 0x3f800000 
//   float FarClipPlane_id110;          // Offset:  356 Size:     4 [unused]
//      = 0x42c80000 
//   float2 ZProjection_id111;          // Offset:  360 Size:     8 [unused]
//   float2 ViewSize_id112;             // Offset:  368 Size:     8 [unused]
//   float AspectRatio_id113;           // Offset:  376 Size:     4 [unused]
//   float4 _padding_PerView_Default;   // Offset:  384 Size:    16 [unused]
//   float ClusterDepthScale_id118;     // Offset:  400 Size:     4 [unused]
//   float ClusterDepthBias_id119;      // Offset:  404 Size:     4 [unused]
//   float2 ClusterStride_id120;        // Offset:  408 Size:     8 [unused]
//   float3 AmbientLight_id123;         // Offset:  416 Size:    12 [unused]
//   float3 SphericalColors_id128[25];  // Offset:  432 Size:   396 [unused]
//   float MipCount_id187;              // Offset:  828 Size:     4 [unused]
//   float4x4 SkyMatrix_id189;          // Offset:  832 Size:    64 [unused]
//   float Intensity_id190;             // Offset:  896 Size:     4 [unused]
//   float4 _padding_PerView_Lighting;  // Offset:  912 Size:    16 [unused]
//
// }
//
//
// Resource Bindings:
//
// Name                                 Type  Format         Dim      HLSL Bind  Count
// ------------------------------ ---------- ------- ----------- -------------- ------
// PerDraw                           cbuffer      NA          NA            cb0      1 
// PerView                           cbuffer      NA          NA            cb1      1 
//
//
//
// Input signature:
//
// Name                 Index   Mask Register SysValue  Format   Used
// -------------------- ----- ------ -------- -------- ------- ------
// POSITION                 0   xyzw        0     NONE   float   xyzw
// NORMAL                   0   xyz         1     NONE   float   xyz 
// TANGENT                  0   xyzw        2     NONE   float   xyzw
// TEXCOORD                 0   xy          3     NONE   float   xy  
//
//
// Output signature:
//
// Name                 Index   Mask Register SysValue  Format   Used
// -------------------- ----- ------ -------- -------- ------- ------
// POSITION_WS              0   xyzw        0     NONE   float   xyzw
// SV_Position              0   xyzw        1      POS   float   xyzw
// SCREENPOSITION_ID108_SEM     0   xyzw        2     NONE   float   xyzw
// NORMAL                   0   xyz         3     NONE   float   xyz 
// TANGENT                  0   xyzw        4     NONE   float   xyzw
// TEXCOORD                 0   xy          5     NONE   float   xy  
// POSITION                 0   xyzw        6     NONE   float   xyzw
//
vs_5_0
dcl_globalFlags refactoringAllowed
dcl_constantbuffer CB0[4], immediateIndexed
dcl_constantbuffer CB1[20], immediateIndexed
dcl_input v0.xyzw
dcl_input v1.xyz
dcl_input v2.xyzw
dcl_input v3.xy
dcl_output o0.xyzw
dcl_output_siv o1.xyzw, position
dcl_output o2.xyzw
dcl_output o3.xyz
dcl_output o4.xyzw
dcl_output o5.xy
dcl_output o6.xyzw
dcl_temps 2
//
// Initial variable locations:
//   v0.x <- __input__.Position_id20.x; v0.y <- __input__.Position_id20.y; v0.z <- __input__.Position_id20.z; v0.w <- __input__.Position_id20.w; 
//   v1.x <- __input__.meshNormal_id15.x; v1.y <- __input__.meshNormal_id15.y; v1.z <- __input__.meshNormal_id15.z; 
//   v2.x <- __input__.meshTangent_id17.x; v2.y <- __input__.meshTangent_id17.y; v2.z <- __input__.meshTangent_id17.z; v2.w <- __input__.meshTangent_id17.w; 
//   v3.x <- __input__.TexCoord_id177.x; v3.y <- __input__.TexCoord_id177.y; 
//   o6.x <- <VSMain return value>.Position_id20.x; o6.y <- <VSMain return value>.Position_id20.y; o6.z <- <VSMain return value>.Position_id20.z; o6.w <- <VSMain return value>.Position_id20.w; 
//   o5.x <- <VSMain return value>.TexCoord_id177.x; o5.y <- <VSMain return value>.TexCoord_id177.y; 
//   o4.x <- <VSMain return value>.meshTangent_id17.x; o4.y <- <VSMain return value>.meshTangent_id17.y; o4.z <- <VSMain return value>.meshTangent_id17.z; o4.w <- <VSMain return value>.meshTangent_id17.w; 
//   o3.x <- <VSMain return value>.meshNormal_id15.x; o3.y <- <VSMain return value>.meshNormal_id15.y; o3.z <- <VSMain return value>.meshNormal_id15.z; 
//   o2.x <- <VSMain return value>.ScreenPosition_id108.x; o2.y <- <VSMain return value>.ScreenPosition_id108.y; o2.z <- <VSMain return value>.ScreenPosition_id108.z; o2.w <- <VSMain return value>.ScreenPosition_id108.w; 
//   o1.x <- <VSMain return value>.ShadingPosition_id0.x; o1.y <- <VSMain return value>.ShadingPosition_id0.y; o1.z <- <VSMain return value>.ShadingPosition_id0.z; o1.w <- <VSMain return value>.ShadingPosition_id0.w; 
//   o0.x <- <VSMain return value>.PositionWS_id21.x; o0.y <- <VSMain return value>.PositionWS_id21.y; o0.z <- <VSMain return value>.PositionWS_id21.z; o0.w <- <VSMain return value>.PositionWS_id21.w
//
#line 1111 "G:\Games\steamapps\common\Distant Worlds 2\log\shader_DW_ForwardShader_847a012159b2422ca156d471253d73a6.hlsl"
dp4 r0.x, v0.xyzw, cb0[0].xyzw  // r0.x <- streams.PositionWS_id21.x
dp4 r0.y, v0.xyzw, cb0[1].xyzw  // r0.y <- streams.PositionWS_id21.y
dp4 r0.z, v0.xyzw, cb0[2].xyzw  // r0.z <- streams.PositionWS_id21.z
dp4 r0.w, v0.xyzw, cb0[3].xyzw  // r0.w <- streams.PositionWS_id21.w

#line 1247
mov o0.xyzw, r0.xyzw

#line 1035
dp4 r1.x, r0.xyzw, cb1[16].xyzw  // r1.x <- <ComputeShadingPosition_id11 return value>.x
dp4 r1.y, r0.xyzw, cb1[17].xyzw  // r1.y <- <ComputeShadingPosition_id11 return value>.y
dp4 r1.z, r0.xyzw, cb1[18].xyzw  // r1.z <- <ComputeShadingPosition_id11 return value>.z
dp4 r1.w, r0.xyzw, cb1[19].xyzw  // r1.w <- <ComputeShadingPosition_id11 return value>.w

#line 1247
mov o1.xyzw, r1.xyzw
mov o2.xyzw, r1.xyzw
mov o3.xyz, v1.xyzx
mov o4.xyzw, v2.xyzw
mov o5.xy, v3.xyxx
mov o6.xyzw, v0.xyzw
ret 
// Approximately 16 instruction slots used
@G    Pixel => 7444bde46f49d7bf974f2fcbfb17603f
//
// Generated by Microsoft (R) HLSL Shader Compiler 10.1
//
//
// Buffer Definitions: 
//
// cbuffer PerDraw
// {
//
//   float4x4 World_id31;               // Offset:    0 Size:    64 [unused]
//   float4x4 WorldInverse_id32;        // Offset:   64 Size:    64 [unused]
//   float4x4 WorldInverseTranspose_id33;// Offset:  128 Size:    64
//   float4x4 WorldView_id34;           // Offset:  192 Size:    64 [unused]
//   float4x4 WorldViewInverse_id35;    // Offset:  256 Size:    64 [unused]
//   float4x4 WorldViewProjection_id36; // Offset:  320 Size:    64 [unused]
//   float3 WorldScale_id37;            // Offset:  384 Size:    12 [unused]
//   float4 EyeMS_id38;                 // Offset:  400 Size:    16 [unused]
//   float3 DW_NoiseOffset_id96;        // Offset:  416 Size:    12
//      = 0x00000000 0x00000000 0x00000000 
//   float DW_NoiseScale_id97;          // Offset:  428 Size:     4
//      = 0x41200000 
//   float DW_DamageLevel_id98;         // Offset:  432 Size:     4
//      = 0x00000000 
//   float DW_NoiseOffsetFactor_id99;   // Offset:  436 Size:     4 [unused]
//      = 0x3f800000 
//   float DW_ConstructionLevel_id100;  // Offset:  440 Size:     4
//      = 0x3f800000 
//   float DW_TimeValue_id101;          // Offset:  444 Size:     4
//   float4 DW_NoiseColorLow_id102;     // Offset:  448 Size:    16
//      = 0x3f000000 0x00000000 0x00000000 0x3f800000 
//   float4 DW_NoiseColorLowAdd_id103;  // Offset:  464 Size:    16
//      = 0x3f99999a 0x3f19999a 0x00000000 0x3f800000 
//   float4 DW_NoiseColorHigh_id104;    // Offset:  480 Size:    16 [unused]
//      = 0x3f800000 0x3f800000 0x00000000 0x3f800000 
//   float4 DW_NoiseColorHighAdd_id105; // Offset:  496 Size:    16 [unused]
//      = 0x40333333 0x40000000 0x3ff33333 0x3f800000 
//
// }
//
// cbuffer PerMaterial
// {
//
//   float2 scale_id196;                // Offset:    0 Size:     8
//   float2 offset_id197;               // Offset:    8 Size:     8
//   float2 scale_id201;                // Offset:   16 Size:     8
//   float2 offset_id202;               // Offset:   24 Size:     8
//   float2 scale_id208;                // Offset:   32 Size:     8
//   float2 offset_id209;               // Offset:   40 Size:     8
//   float4 constantColor_id215;        // Offset:   48 Size:    16
//   float constantFloat_id217;         // Offset:   64 Size:     4
//   float2 scale_id221;                // Offset:   68 Size:     8
//   float2 offset_id222;               // Offset:   80 Size:     8
//   float constantFloat_id224;         // Offset:   88 Size:     4
//   float constantFloat_id226;         // Offset:   92 Size:     4
//   float constantFloat_id228;         // Offset:   96 Size:     4
//   float constantFloat_id230;         // Offset:  100 Size:     4
//   float2 scale_id234;                // Offset:  104 Size:     8
//   float2 offset_id235;               // Offset:  112 Size:     8
//   float constantFloat_id237;         // Offset:  120 Size:     4
//
// }
//
// cbuffer PerView
// {
//
//   float4x4 View_id24;                // Offset:    0 Size:    64 [unused]
//   float4x4 ViewInverse_id25;         // Offset:   64 Size:    64 [unused]
//   float4x4 Projection_id26;          // Offset:  128 Size:    64 [unused]
//   float4x4 ProjectionInverse_id27;   // Offset:  192 Size:    64 [unused]
//   float4x4 ViewProjection_id28;      // Offset:  256 Size:    64 [unused]
//   float2 ProjScreenRay_id29;         // Offset:  320 Size:     8 [unused]
//   float4 Eye_id30;                   // Offset:  336 Size:    16
//   float NearClipPlane_id109;         // Offset:  352 Size:     4 [unused]
//      = 0x3f800000 
//   float FarClipPlane_id110;          // Offset:  356 Size:     4 [unused]
//      = 0x42c80000 
//   float2 ZProjection_id111;          // Offset:  360 Size:     8
//   float2 ViewSize_id112;             // Offset:  368 Size:     8 [unused]
//   float AspectRatio_id113;           // Offset:  376 Size:     4 [unused]
//   float4 _padding_PerView_Default;   // Offset:  384 Size:    16 [unused]
//   float ClusterDepthScale_id118;     // Offset:  400 Size:     4
//   float ClusterDepthBias_id119;      // Offset:  404 Size:     4
//   float2 ClusterStride_id120;        // Offset:  408 Size:     8
//   float3 AmbientLight_id123;         // Offset:  416 Size:    12
//   float3 SphericalColors_id128[25];  // Offset:  432 Size:   396
//   float MipCount_id187;              // Offset:  828 Size:     4
//   float4x4 SkyMatrix_id189;          // Offset:  832 Size:    64
//   float Intensity_id190;             // Offset:  896 Size:     4
//   float4 _padding_PerView_Lighting;  // Offset:  912 Size:    16 [unused]
//
// }
//
//
// Resource Bindings:
//
// Name                                 Type  Format         Dim      HLSL Bind  Count
// ------------------------------ ---------- ------- ----------- -------------- ------
// NoiseTextureCoarse3DSampler_id85    sampler      NA          NA             s0      1 
// LinearSampler_id159               sampler      NA          NA             s1      1 
// Sampler_id194                     sampler      NA          NA             s2      1 
// NoiseTextureCoarse3D_id84         texture  float4          3d             t0      1 
// Texture_id193                     texture  float4          2d             t1      1 
// Texture_id199                     texture  float4          2d             t2      1 
// Texture_id206                     texture  float4          2d             t3      1 
// Texture_id219                     texture  float4          2d             t4      1 
// Texture_id232                     texture  float4          2d             t5      1 
// EnvironmentLightingDFG_LUT_id244    texture  float4          2d             t6      1 
// LightClusters_id116               texture   uint2          3d             t7      1 
// LightIndices_id117                texture    uint         buf             t8      1 
// PointLights_id121                 texture  float4         buf             t9      1 
// SpotLights_id122                  texture  float4         buf            t10      1 
// CubeMap_id188                     texture  float4        cube            t11      1 
// PerDraw                           cbuffer      NA          NA            cb0      1 
// PerMaterial                       cbuffer      NA          NA            cb1      1 
// PerView                           cbuffer      NA          NA            cb2      1 
//
//
//
// Input signature:
//
// Name                 Index   Mask Register SysValue  Format   Used
// -------------------- ----- ------ -------- -------- ------- ------
// POSITION_WS              0   xyzw        0     NONE   float   xyz 
// SV_Position              0   xyzw        1      POS   float     z 
// SCREENPOSITION_ID108_SEM     0   xyzw        2     NONE   float   xy w
// NORMAL                   0   xyz         3     NONE   float   xyz 
// TANGENT                  0   xyzw        4     NONE   float   xyzw
// TEXCOORD                 0   xy          5     NONE   float   xy  
// POSITION                 0   xyzw        6     NONE   float   xyz 
// SV_IsFrontFace           0   x           7    FFACE    uint   x   
//
//
// Output signature:
//
// Name                 Index   Mask Register SysValue  Format   Used
// -------------------- ----- ------ -------- -------- ------- ------
// SV_Target                0   xyzw        0   TARGET   float   xyzw
//
ps_5_0
dcl_globalFlags refactoringAllowed
dcl_constantbuffer CB0[30], immediateIndexed
dcl_constantbuffer CB1[8], immediateIndexed
dcl_constantbuffer CB2[57], immediateIndexed
dcl_sampler s0, mode_default
dcl_sampler s1, mode_default
dcl_sampler s2, mode_default
dcl_resource_texture3d (float,float,float,float) t0
dcl_resource_texture2d (float,float,float,float) t1
dcl_resource_texture2d (float,float,float,float) t2
dcl_resource_texture2d (float,float,float,float) t3
dcl_resource_texture2d (float,float,float,float) t4
dcl_resource_texture2d (float,float,float,float) t5
dcl_resource_texture2d (float,float,float,float) t6
dcl_resource_texture3d (uint,uint,uint,uint) t7
dcl_resource_buffer (uint,uint,uint,uint) t8
dcl_resource_buffer (float,float,float,float) t9
dcl_resource_buffer (float,float,float,float) t10
dcl_resource_texturecube (float,float,float,float) t11
dcl_input_ps linear v0.xyz
dcl_input_ps_siv linear noperspective v1.z, position
dcl_input_ps linear v2.xyw
dcl_input_ps linear v3.xyz
dcl_input_ps linear v4.xyzw
dcl_input_ps linear v5.xy
dcl_input_ps linear v6.xyz
dcl_input_ps_sgv constant v7.x, is_front_face
dcl_output o0.xyzw
dcl_temps 20
//
// Initial variable locations:
//   v0.x <- __input__.PositionWS_id21.x; v0.y <- __input__.PositionWS_id21.y; v0.z <- __input__.PositionWS_id21.z; v0.w <- __input__.PositionWS_id21.w; 
//   v1.x <- __input__.ShadingPosition_id0.x; v1.y <- __input__.ShadingPosition_id0.y; v1.z <- __input__.ShadingPosition_id0.z; v1.w <- __input__.ShadingPosition_id0.w; 
//   v2.x <- __input__.ScreenPosition_id108.x; v2.y <- __input__.ScreenPosition_id108.y; v2.z <- __input__.ScreenPosition_id108.z; v2.w <- __input__.ScreenPosition_id108.w; 
//   v3.x <- __input__.meshNormal_id15.x; v3.y <- __input__.meshNormal_id15.y; v3.z <- __input__.meshNormal_id15.z; 
//   v4.x <- __input__.meshTangent_id17.x; v4.y <- __input__.meshTangent_id17.y; v4.z <- __input__.meshTangent_id17.z; v4.w <- __input__.meshTangent_id17.w; 
//   v5.x <- __input__.TexCoord_id177.x; v5.y <- __input__.TexCoord_id177.y; 
//   v6.x <- __input__.Position_id20.x; v6.y <- __input__.Position_id20.y; v6.z <- __input__.Position_id20.z; v6.w <- __input__.Position_id20.w; 
//   v7.x <- __input__.IsFrontFace_id1
//
#line 1224 "G:\Games\steamapps\common\Distant Worlds 2\log\shader_DW_ForwardShader_847a012159b2422ca156d471253d73a6.hlsl"
div r0.xy, v2.xyxx, v2.wwww  // r0.x <- streams.ScreenPosition_id108.x; r0.y <- streams.ScreenPosition_id108.y

#line 1092
dp3 r0.z, v3.xyzx, v3.xyzx
rsq r0.z, r0.z
mul r1.xyz, r0.zzzz, v3.xyzx  // r1.x <- streams.meshNormal_id15.x; r1.y <- streams.meshNormal_id15.y; r1.z <- streams.meshNormal_id15.z

#line 1093
dp3 r0.z, v4.xyzx, v4.xyzx
rsq r0.z, r0.z
mul r2.xyz, r0.zzzz, v4.xyzx  // r2.x <- tangent.x; r2.y <- tangent.y; r2.z <- tangent.z

#line 1094
mul r3.xyz, r1.zxyz, r2.yzxy
mad r3.xyz, r1.yzxy, r2.zxyz, -r3.xyzx
mul r3.xyz, r3.xyzx, v4.wwww  // r3.x <- bitangent.x; r3.y <- bitangent.y; r3.z <- bitangent.z

#line 1169
dp3 r4.x, r2.xyzx, cb0[8].xyzx  // r4.x <- streams.tangentToWorld_id19._m00
dp3 r5.x, r2.xyzx, cb0[9].xyzx  // r5.x <- streams.tangentToWorld_id19._m01
dp3 r2.x, r2.xyzx, cb0[10].xyzx  // r2.x <- streams.tangentToWorld_id19._m02
dp3 r4.y, r3.xyzx, cb0[8].xyzx  // r4.y <- streams.tangentToWorld_id19._m10
dp3 r5.y, r3.xyzx, cb0[9].xyzx  // r5.y <- streams.tangentToWorld_id19._m11
dp3 r2.y, r3.xyzx, cb0[10].xyzx  // r2.y <- streams.tangentToWorld_id19._m12
dp3 r4.z, r1.xyzx, cb0[8].xyzx  // r4.z <- streams.tangentToWorld_id19._m20
dp3 r5.z, r1.xyzx, cb0[9].xyzx  // r5.z <- streams.tangentToWorld_id19._m21
dp3 r2.z, r1.xyzx, cb0[10].xyzx  // r2.z <- streams.tangentToWorld_id19._m22

#line 1079
add r1.xyz, -v0.xyzx, cb2[21].xyzx
dp3 r0.z, r1.xyzx, r1.xyzx
rsq r0.z, r0.z
mul r1.xyz, r0.zzzz, r1.xyzx  // r1.x <- streams.viewWS_id66.x; r1.y <- streams.viewWS_id66.y; r1.z <- streams.viewWS_id66.z

#line 748
mad r0.zw, v5.xxxy, cb1[0].xxxy, cb1[0].zzzw
sample_indexable(texture2d)(float,float,float,float) r3.xyzw, r0.zwzz, t1.xyzw, s2  // r3.x <- <Compute_id304 return value>.x; r3.y <- <Compute_id304 return value>.y; r3.z <- <Compute_id304 return value>.z; r3.w <- <Compute_id304 return value>.w

#line 744
mad r0.zw, v5.xxxy, cb1[1].xxxy, cb1[1].zzzw
sample_indexable(texture2d)(float,float,float,float) r0.zw, r0.zwzz, t2.zwxy, s2  // r0.z <- <Compute_id306 return value>.x; r0.w <- <Compute_id306 return value>.y

#line 910
mad r6.xy, r0.zwzz, l(2.000000, 2.000000, 0.000000, 0.000000), l(-1.000000, -1.000000, 0.000000, 0.000000)  // r6.x <- normal.x; r6.y <- normal.y

#line 914
dp2 r0.z, r6.xyxx, r6.xyxx
add r0.z, -r0.z, l(1.000000)
max r0.z, r0.z, l(0.000000)
sqrt r6.z, r0.z  // r6.z <- normal.z

#line 740
mad r0.zw, v5.xxxy, cb1[2].xxxy, cb1[2].zzzw
sample_indexable(texture2d)(float,float,float,float) r0.z, r0.zwzz, t3.xzyw, s2  // r0.z <- <Compute_id308 return value>.x

#line 728
mad r7.xy, v5.xyxx, cb1[4].yzyy, cb1[5].xyxx
sample_indexable(texture2d)(float,float,float,float) r0.w, r7.xyxx, t4.xywz, s2  // r0.w <- <Compute_id314 return value>.x

#line 708
mad r7.xy, v5.xyxx, cb1[6].zwzz, cb1[7].xyxx
sample_indexable(texture2d)(float,float,float,float) r7.xyz, r7.xyxx, t5.xyzw, s2  // r7.x <- <Compute_id324 return value>.x; r7.y <- <Compute_id324 return value>.y; r7.z <- <Compute_id324 return value>.z

#line 700
dp3 r4.x, r6.xyzx, r4.xyzx
dp3 r4.y, r6.xyzx, r5.xyzx
dp3 r4.z, r6.xyzx, r2.xyzx
dp3 r1.w, r4.xyzx, r4.xyzx
rsq r1.w, r1.w
mul r2.xyz, r1.wwww, r4.xyzx  // r2.x <- streams.normalWS_id18.x; r2.y <- streams.normalWS_id18.y; r2.z <- streams.normalWS_id18.z

#line 768
movc r2.xyz, v7.xxxx, r2.xyzx, -r2.xyzx  // r2.x <- streams.normalWS_id18.x; r2.y <- streams.normalWS_id18.y; r2.z <- streams.normalWS_id18.z

#line 679
add r1.w, r0.w, l(-1.000000)
mad r1.w, cb1[5].z, r1.w, l(1.000000)  // r1.w <- streams.lightDirectAmbientOcclusion_id48

#line 680
add r2.w, cb1[5].w, l(-1.000000)

#line 681
mad r4.xy, cb1[6].xyxx, r2.wwww, l(1.000000, 1.000000, 0.000000, 0.000000)

#line 680
mul r4.xzw, r3.xxyz, r4.xxxx  // r4.x <- streams.matDiffuseVisible_id67.x; r4.z <- streams.matDiffuseVisible_id67.y; r4.w <- streams.matDiffuseVisible_id67.z

#line 681
mul r5.xyz, cb1[3].xyzx, cb1[4].xxxx
mul r6.xyz, r4.yyyy, r5.xyzx  // r6.x <- streams.matSpecularVisible_id69.x; r6.y <- streams.matSpecularVisible_id69.y; r6.z <- streams.matSpecularVisible_id69.z

#line 682
dp3 r2.w, r2.xyzx, r1.xyzx
max r8.y, r2.w, l(0.000100)  // r8.y <- streams.NdotV_id70

#line 683
add r0.z, -r0.z, l(1.000000)  // r0.z <- roughness

#line 684
mul r0.z, r0.z, r0.z
max r0.z, r0.z, l(0.001000)  // r0.z <- streams.alphaRoughness_id68

#line 553
add r2.w, v1.z, -cb2[22].z
div r2.w, cb2[22].w, r2.w  // r2.w <- depth

#line 554
mad r0.xy, r0.xyxx, l(1.000000, -1.000000, 0.000000, 0.000000), l(1.000000, 1.000000, 0.000000, 0.000000)
mul r0.xy, r0.xyxx, cb2[25].zwzz

#line 555
mad r2.w, r2.w, cb2[25].x, cb2[25].y
log r2.w, r2.w
max r2.w, r2.w, l(0.000000)
ftoi r9.z, r2.w  // r9.z <- slice

#line 556
mul r0.xy, r0.xyxx, l(0.500000, 0.500000, 0.000000, 0.000000)
ftoi r9.xy, r0.xyxx
mov r9.w, l(0)
ld_indexable(texture3d)(uint,uint,uint,uint) r0.xy, r9.xyzw, t7.xyzw  // r0.x <- streams.lightData_id114.x; r0.y <- streams.lightData_id114.y

#line 665
and r2.w, r0.y, l(0x0000ffff)  // r2.w <- <GetMaxLightCount_id260 return value>

#line 786
mov r9.xyz, v0.xyzx  // r9.x <- streams.PositionWS_id21.x; r9.y <- streams.PositionWS_id21.y; r9.z <- streams.PositionWS_id21.z
mov r10.xyz, r1.xyzx  // r10.x <- streams.viewWS_id66.x; r10.y <- streams.viewWS_id66.y; r10.z <- streams.viewWS_id66.z
mov r11.xyz, r4.xzwx  // r11.x <- streams.matDiffuseVisible_id67.x; r11.y <- streams.matDiffuseVisible_id67.y; r11.z <- streams.matDiffuseVisible_id67.z
mov r12.xyz, r6.xyzx  // r12.x <- streams.matSpecularVisible_id69.x; r12.y <- streams.matSpecularVisible_id69.y; r12.z <- streams.matSpecularVisible_id69.z
mov r12.w, r0.z  // r12.w <- streams.alphaRoughness_id68
mov r13.x, r2.x  // r13.x <- streams.normalWS_id18.x
mov r14.xy, r2.yzyy  // r14.x <- streams.normalWS_id18.y; r14.y <- streams.normalWS_id18.z
mov r14.z, r1.w  // r14.z <- streams.lightDirectAmbientOcclusion_id48
mov r15.xyz, l(0,0,0,0)  // r15.x <- directLightingContribution.x; r15.y <- directLightingContribution.y; r15.z <- directLightingContribution.z
mov r16.x, r0.x  // r16.x <- streams.lightIndex_id115
mov r5.w, l(0)  // r5.w <- i
loop 
  ige r6.w, r5.w, r2.w
  breakc_nz r6.w

#line 788
  if_nz r6.w

#line 790
    break 

#line 791
  endif 

#line 540
  ld_indexable(buffer)(uint,uint,uint,uint) r6.w, r16.xxxx, t8.yzwx  // r6.w <- realLightIndex

#line 541
  iadd r16.x, r16.x, l(1)  // r16.x <- streams.lightIndex_id115

#line 543
  ishl r7.w, r6.w, l(1)
  ld_indexable(buffer)(float,float,float,float) r17.xyzw, r7.wwww, t9.xyzw  // r17.x <- pointLight1.x; r17.y <- pointLight1.y; r17.z <- pointLight1.z; r17.w <- pointLight1.w

#line 544
  bfi r6.w, l(31), l(1), r6.w, l(1)
  ld_indexable(buffer)(float,float,float,float) r16.yzw, r6.wwww, t9.wxyz  // r16.y <- pointLight2.x; r16.z <- pointLight2.y; r16.w <- pointLight2.z

#line 374
  add r17.xyz, -r9.xyzx, r17.xyzx  // r17.x <- lightVector.x; r17.y <- lightVector.y; r17.z <- lightVector.z

#line 375
  dp3 r6.w, r17.xyzx, r17.xyzx
  sqrt r7.w, r6.w  // r7.w <- lightVectorLength

#line 376
  div r17.xyz, r17.xyzx, r7.wwww  // r17.x <- lightVectorNorm.x; r17.y <- lightVectorNorm.y; r17.z <- lightVectorNorm.z

#line 347
  max r7.w, r6.w, l(0.000100)
  div r7.w, l(1.000000, 1.000000, 1.000000, 1.000000), r7.w  // r7.w <- attenuation

#line 326
  mul r6.w, r17.w, r6.w  // r6.w <- factor

#line 327
  mad r6.w, -r6.w, r6.w, l(1.000000)
  max r6.w, r6.w, l(0.000000)  // r6.w <- smoothFactor

#line 328
  mul r6.w, r6.w, r6.w  // r6.w <- <SmoothDistanceAttenuation_id106 return value>

#line 348
  mul r6.w, r6.w, r7.w  // r6.w <- attenuation

#line 456
  mul r16.yzw, r6.wwww, r16.yyzw  // r16.y <- streams.lightColor_id42.x; r16.z <- streams.lightColor_id42.y; r16.w <- streams.lightColor_id42.z

#line 651
  mov r13.yz, r14.xxyx
  dp3 r6.w, r13.xyzx, r17.xyzx
  max r6.w, r6.w, l(0.000100)  // r6.w <- streams.NdotL_id47

#line 653
  mul r16.yzw, r6.wwww, r16.yyzw
  mul r16.yzw, r14.zzzz, r16.yyzw  // r16.y <- streams.lightColorNdotL_id43.x; r16.z <- streams.lightColorNdotL_id43.y; r16.w <- streams.lightColorNdotL_id43.z

#line 643
  add r18.xyz, r17.xyzx, r10.xyzx
  dp3 r6.w, r18.xyzx, r18.xyzx
  rsq r6.w, r6.w
  mul r18.xyz, r6.wwww, r18.xyzx  // r18.x <- streams.H_id73.x; r18.y <- streams.H_id73.y; r18.z <- streams.H_id73.z

#line 644
  dp3_sat r6.w, r13.xyzx, r18.xyzx  // r6.w <- streams.NdotH_id74

#line 645
  dp3_sat r7.w, r17.xyzx, r18.xyzx  // r7.w <- streams.LdotH_id75

#line 637
  add r13.yzw, -r12.xxyz, l(0.000000, 1.000000, 1.000000, 1.000000)
  mul r17.xyz, r11.xyzx, r13.yzwy  // r17.x <- diffuseColor.x; r17.y <- diffuseColor.y; r17.z <- diffuseColor.z

#line 639
  mul r17.xyz, r16.yzwy, r17.xyzx

#line 796
  mad r17.xyz, r17.xyzx, l(0.318310, 0.318310, 0.318310, 0.000000), r15.xyzx  // r17.x <- directLightingContribution.x; r17.y <- directLightingContribution.y; r17.z <- directLightingContribution.z

#line 370
  add r7.w, -r7.w, l(1.000000)
  mul r8.z, r7.w, r7.w
  mul r8.z, r8.z, r8.z
  mul r7.w, r7.w, r8.z
  mad r13.yzw, r13.yyzw, r7.wwww, r12.xxyz  // r13.y <- <FresnelSchlick_id212 return value>.x; r13.z <- <FresnelSchlick_id212 return value>.y; r13.w <- <FresnelSchlick_id212 return value>.z

#line 440
  mul r7.w, r12.w, r12.w
  max r7.w, r7.w, l(0.100000)  // r7.w <- alphaR2

#line 441
  div r8.z, l(2.000000), r7.w
  add r8.z, r8.z, l(-2.000000)

#line 366
  max r6.w, r6.w, l(0.000010)
  log r6.w, r6.w
  mul r6.w, r6.w, r8.z
  exp r6.w, r6.w  // r6.w <- <ClampedPow_id234 return value>

#line 441
  mul r7.w, r7.w, l(3.141593)
  div r6.w, r6.w, r7.w  // r6.w <- <NormalDistributionBlinnPhong_id240 return value>

#line 629
  mul r13.yzw, r6.wwww, r13.yyzw
  mul r13.yzw, r16.yyzw, r13.yyzw

#line 800
  mad r15.xyz, r13.yzwy, l(0.250000, 0.250000, 0.250000, 0.000000), r17.xyzx  // r15.x <- directLightingContribution.x; r15.y <- directLightingContribution.y; r15.z <- directLightingContribution.z

#line 786
  iadd r5.w, r5.w, l(1)

#line 802
endloop   // r16.x <- streams.lightIndex_id115

#line 618
ushr r0.x, r0.y, l(16)  // r0.x <- <GetMaxLightCount_id272 return value>

#line 810
mov r9.xyz, v0.xyzx
mov r9.w, r1.w  // r9.w <- streams.lightDirectAmbientOcclusion_id48
mov r0.y, r0.z  // r0.y <- streams.alphaRoughness_id68
mov r10.xyz, r1.xyzx
mov r11.xyz, r4.xzwx
mov r12.xyz, r6.xyzx
mov r13.xyz, r2.xyzx  // r13.y <- streams.normalWS_id18.y; r13.z <- streams.normalWS_id18.z
mov r14.xyz, r15.xyzx  // r14.x <- directLightingContribution.x; r14.y <- directLightingContribution.y; r14.z <- directLightingContribution.z
mov r2.w, r16.x  // r2.w <- streams.lightIndex_id115
mov r5.w, l(0)  // r5.w <- i
loop 
  ige r6.w, r5.w, r0.x
  breakc_nz r6.w

#line 812
  if_nz r6.w

#line 814
    break 

#line 815
  endif 

#line 500
  ld_indexable(buffer)(uint,uint,uint,uint) r6.w, r2.wwww, t8.yzwx  // r6.w <- realLightIndex

#line 501
  iadd r2.w, r2.w, l(1)  // r2.w <- streams.lightIndex_id115

#line 503
  ishl r7.w, r6.w, l(2)
  ld_indexable(buffer)(float,float,float,float) r16.yzw, r7.wwww, t10.wxyz  // r16.y <- spotLight1.x; r16.z <- spotLight1.y; r16.w <- spotLight1.z

#line 506
  bfi r17.xyz, l(30, 30, 30, 0), l(2, 2, 2, 0), r6.wwww, l(1, 2, 3, 0)

#line 504
  ld_indexable(buffer)(float,float,float,float) r18.xyz, r17.xxxx, t10.xyzw  // r18.x <- spotLight2.x; r18.y <- spotLight2.y; r18.z <- spotLight2.z

#line 505
  ld_indexable(buffer)(float,float,float,float) r17.xyw, r17.yyyy, t10.xywz  // r17.x <- spotLight3.x; r17.y <- spotLight3.y; r17.w <- spotLight3.z

#line 506
  ld_indexable(buffer)(float,float,float,float) r19.xyz, r17.zzzz, t10.xyzw  // r19.x <- spotLight4.x; r19.y <- spotLight4.y; r19.z <- spotLight4.z

#line 353
  add r16.yzw, -r9.xxyz, r16.yyzw  // r16.y <- lightVector.x; r16.z <- lightVector.y; r16.w <- lightVector.z

#line 354
  dp3 r6.w, r16.yzwy, r16.yzwy
  sqrt r7.w, r6.w  // r7.w <- lightVectorLength

#line 355
  div r16.yzw, r16.yyzw, r7.wwww  // r16.y <- lightVectorNorm.x; r16.z <- lightVectorNorm.y; r16.w <- lightVectorNorm.z

#line 340
  max r7.w, r6.w, l(0.000100)
  div r7.w, l(1.000000, 1.000000, 1.000000, 1.000000), r7.w  // r7.w <- attenuation

#line 320
  mul r6.w, r17.w, r6.w  // r6.w <- factor

#line 321
  mad r6.w, -r6.w, r6.w, l(1.000000)
  max r6.w, r6.w, l(0.000000)  // r6.w <- smoothFactor

#line 322
  mul r6.w, r6.w, r6.w  // r6.w <- <SmoothDistanceAttenuation_id117 return value>

#line 341
  mul r6.w, r6.w, r7.w  // r6.w <- attenuation

#line 332
  dp3 r7.w, -r18.xyzx, r16.yzwy  // r7.w <- cd

#line 333
  mad_sat r7.w, r7.w, r17.x, r17.y  // r7.w <- attenuation

#line 334
  mul r7.w, r7.w, r7.w

#line 361
  mul r6.w, r6.w, r7.w  // r6.w <- attenuation

#line 435
  mul r17.xyz, r6.wwww, r19.xyzx  // r17.x <- streams.lightColor_id42.x; r17.y <- streams.lightColor_id42.y; r17.z <- streams.lightColor_id42.z

#line 604
  dp3 r6.w, r13.xyzx, r16.yzwy
  max r6.w, r6.w, l(0.000100)  // r6.w <- streams.NdotL_id47

#line 606
  mul r17.xyz, r6.wwww, r17.xyzx
  mul r17.xyz, r9.wwww, r17.xyzx  // r17.x <- streams.lightColorNdotL_id43.x; r17.y <- streams.lightColorNdotL_id43.y; r17.z <- streams.lightColorNdotL_id43.z

#line 643
  add r18.xyz, r10.xyzx, r16.yzwy
  dp3 r6.w, r18.xyzx, r18.xyzx
  rsq r6.w, r6.w
  mul r18.xyz, r6.wwww, r18.xyzx  // r18.x <- streams.H_id73.x; r18.y <- streams.H_id73.y; r18.z <- streams.H_id73.z

#line 644
  dp3_sat r6.w, r13.xyzx, r18.xyzx  // r6.w <- streams.NdotH_id74

#line 645
  dp3_sat r7.w, r16.yzwy, r18.xyzx  // r7.w <- streams.LdotH_id75

#line 637
  add r16.yzw, -r12.xxyz, l(0.000000, 1.000000, 1.000000, 1.000000)
  mul r18.xyz, r11.xyzx, r16.yzwy  // r18.x <- diffuseColor.x; r18.y <- diffuseColor.y; r18.z <- diffuseColor.z

#line 639
  mul r18.xyz, r17.xyzx, r18.xyzx

#line 820
  mad r18.xyz, r18.xyzx, l(0.318310, 0.318310, 0.318310, 0.000000), r14.xyzx  // r18.x <- directLightingContribution.x; r18.y <- directLightingContribution.y; r18.z <- directLightingContribution.z

#line 370
  add r7.w, -r7.w, l(1.000000)
  mul r8.z, r7.w, r7.w
  mul r8.z, r8.z, r8.z
  mul r7.w, r7.w, r8.z
  mad r16.yzw, r16.yyzw, r7.wwww, r12.xxyz  // r16.y <- <FresnelSchlick_id212 return value>.x; r16.z <- <FresnelSchlick_id212 return value>.y; r16.w <- <FresnelSchlick_id212 return value>.z

#line 440
  mul r7.w, r0.y, r0.y
  max r7.w, r7.w, l(0.100000)  // r7.w <- alphaR2

#line 441
  div r8.z, l(2.000000), r7.w
  add r8.z, r8.z, l(-2.000000)

#line 366
  max r6.w, r6.w, l(0.000010)
  log r6.w, r6.w
  mul r6.w, r6.w, r8.z
  exp r6.w, r6.w  // r6.w <- <ClampedPow_id234 return value>

#line 441
  mul r7.w, r7.w, l(3.141593)
  div r6.w, r6.w, r7.w  // r6.w <- <NormalDistributionBlinnPhong_id240 return value>

#line 629
  mul r16.yzw, r6.wwww, r16.yyzw
  mul r16.yzw, r17.xxyz, r16.yyzw

#line 824
  mad r14.xyz, r16.yzwy, l(0.250000, 0.250000, 0.250000, 0.000000), r18.xyzx  // r14.x <- directLightingContribution.x; r14.y <- directLightingContribution.y; r14.z <- directLightingContribution.z

#line 810
  iadd r5.w, r5.w, l(1)

#line 826
endloop   // r2.w <- streams.lightIndex_id115

#line 597
mul r9.xyz, r0.wwww, cb2[26].xyzx  // r9.x <- lightColor.x; r9.y <- lightColor.y; r9.z <- lightColor.z

#line 590
mad r5.xyz, -r5.xyzx, r4.yyyy, l(1.000000, 1.000000, 1.000000, 0.000000)
mul r4.xyz, r4.xzwx, r5.xyzx  // r4.x <- diffuseColor.x; r4.y <- diffuseColor.y; r4.z <- diffuseColor.z

#line 476
sqrt r0.x, r0.z
add r8.x, -r0.x, l(1.000000)  // r8.x <- glossiness

#line 477
sample_l_indexable(texture2d)(float,float,float,float) r0.yz, r8.xyxx, t6.zxyw, s1, l(0.000000)  // r0.y <- environmentLightingDFG.x; r0.z <- environmentLightingDFG.y

#line 478
mad r5.xyz, r6.xyzx, r0.yyyy, r0.zzzz  // r5.x <- <Compute_id328 return value>.x; r5.y <- <Compute_id328 return value>.y; r5.z <- <Compute_id328 return value>.z

#line 583
mul r6.xyz, r9.xyzx, r5.xyzx  // r6.x <- <ComputeEnvironmentLightContribution_id509 return value>.x; r6.y <- <ComputeEnvironmentLightContribution_id509 return value>.y; r6.z <- <ComputeEnvironmentLightContribution_id509 return value>.z

#line 838
mad r6.xyz, r4.xyzx, r9.xyzx, r6.xyzx  // r6.x <- environmentLightingContribution.x; r6.y <- environmentLightingContribution.y; r6.z <- environmentLightingContribution.z

#line 572
dp3 r0.y, r2.xyzx, cb2[52].xyzx  // r0.y <- sampleDirection.x
dp3 r0.z, r2.xyzx, cb2[53].xyzx  // r0.z <- sampleDirection.y
dp3 r1.w, r2.xyzx, cb2[54].xyzx  // r1.w <- sampleDirection.z

#line 385
mul r2.w, r0.y, r0.y  // r2.w <- x2

#line 386
mul r4.w, r0.z, r0.z  // r4.w <- y2

#line 387
mul r5.w, r1.w, r1.w  // r5.w <- z2

#line 391
mad r8.xyz, cb2[28].xyzx, r0.zzzz, cb2[27].xyzx  // r8.x <- color.x; r8.y <- color.y; r8.z <- color.z

#line 392
mad r8.xyz, cb2[29].xyzx, -r1.wwww, r8.xyzx

#line 393
mad r8.xyz, cb2[30].xyzx, r0.yyyy, r8.xyzx

#line 396
mul r9.xyz, r0.zzzz, cb2[31].xyzx
mad r8.xyz, r9.xyzx, r0.yyyy, r8.xyzx

#line 397
mul r9.xyz, r0.zzzz, cb2[32].xyzx
mad r8.xyz, r9.xyzx, -r1.wwww, r8.xyzx

#line 420
mul r6.w, r5.w, l(90.000000)

#line 419
mad r9.xyzw, r5.wwww, l(3.000000, 5.000000, 7.000000, 7.000000), l(-1.000000, -1.000000, -1.000000, -3.000000)

#line 398
mad r8.xyz, cb2[33].xyzx, r9.xxxx, r8.xyzx

#line 399
mul r10.xyz, r0.yyyy, cb2[34].xyzx
mad r8.xyz, r10.xyzx, -r1.wwww, r8.xyzx

#line 400
mad r7.w, r0.y, r0.y, -r4.w
mad r8.xyz, cb2[35].xyzx, r7.wwww, r8.xyzx

#line 403
mul r8.w, -r1.w, r5.w  // r8.w <- z3

#line 406
mul r5.w, r5.w, r5.w  // r5.w <- z4

#line 407
mul r10.xyz, r0.zzzz, cb2[36].xyzx
mad r9.x, r2.w, l(3.000000), -r4.w
mad r8.xyz, r10.xyzx, r9.xxxx, r8.xyzx

#line 408
mul r10.xyz, r0.zzzz, cb2[37].xyzx
mul r10.xyz, r0.yyyy, r10.xyzx
mad r8.xyz, r10.xyzx, -r1.wwww, r8.xyzx

#line 409
mul r10.xyz, r0.zzzz, cb2[38].xyzx
mad r8.xyz, r10.xyzx, r9.yyyy, r8.xyzx

#line 410
mul r10.x, r1.w, l(-3.000000)
mad r8.w, r8.w, l(5.000000), -r10.x
mad r8.xyz, cb2[39].xyzx, r8.wwww, r8.xyzx

#line 411
mul r10.xyz, r0.yyyy, cb2[40].xyzx
mad r8.xyz, r10.xyzx, r9.yyyy, r8.xyzx

#line 412
mul r10.xyz, r7.wwww, cb2[41].xyzx
mad r8.xyz, r10.xyzx, -r1.wwww, r8.xyzx

#line 413
mul r10.xyz, r0.yyyy, cb2[42].xyzx
mad r8.w, -r4.w, l(3.000000), r2.w
mad r8.xyz, r10.xyzx, r8.wwww, r8.xyzx

#line 416
mul r10.xyz, r0.yyyy, cb2[43].xyzx
mul r10.xyz, r0.zzzz, r10.xyzx
mad r8.xyz, r10.xyzx, r7.wwww, r8.xyzx

#line 417
mul r10.xyz, r0.zzzz, cb2[44].xyzx
mul r10.xyz, -r1.wwww, r10.xyzx
mad r8.xyz, r10.xyzx, r9.xxxx, r8.xyzx

#line 418
mul r10.xyz, r0.zzzz, cb2[45].xyzx
mul r10.xyz, r0.yyyy, r10.xyzx
mad r8.xyz, r10.xyzx, r9.zzzz, r8.xyzx

#line 419
mul r10.xyz, r0.zzzz, cb2[46].xyzx
mul r10.xyz, -r1.wwww, r10.xyzx
mad r8.xyz, r10.xyzx, r9.wwww, r8.xyzx

#line 420
mad r0.z, r5.w, l(105.000000), -r6.w
add r0.z, r0.z, l(9.000000)
mad r8.xyz, cb2[47].xyzx, r0.zzzz, r8.xyzx

#line 421
mul r10.xyz, r0.yyyy, cb2[48].xyzx
mul r10.xyz, -r1.wwww, r10.xyzx
mad r8.xyz, r10.xyzx, r9.wwww, r8.xyzx

#line 422
mul r9.xyw, r7.wwww, cb2[49].xyxz
mad r8.xyz, r9.xywx, r9.zzzz, r8.xyzx

#line 423
mul r9.xyz, r0.yyyy, cb2[50].xyzx
mul r9.xyz, -r1.wwww, r9.xyzx
mad r8.xyz, r9.xyzx, r8.wwww, r8.xyzx

#line 424
mul r0.y, r2.w, r4.w
mul r0.y, r0.y, l(6.000000)
mad r0.y, r2.w, r2.w, -r0.y
mad r0.y, r4.w, r4.w, r0.y
mad r8.xyz, cb2[51].xyzx, r0.yyyy, r8.xyzx

#line 574
mul r8.xyz, r8.xyzx, cb2[56].xxxx
mul r8.xyz, r0.wwww, r8.xyzx  // r8.x <- streams.envLightDiffuseColor_id45.x; r8.y <- streams.envLightDiffuseColor_id45.y; r8.z <- streams.envLightDiffuseColor_id45.z

#line 575
dp3 r0.y, -r1.xyzx, r2.xyzx
add r0.y, r0.y, r0.y
mad r1.xyz, r2.xyzx, -r0.yyyy, -r1.xyzx  // r1.x <- sampleDirection.x; r1.y <- sampleDirection.y; r1.z <- sampleDirection.z

#line 576
dp3 r2.x, r1.xyzx, cb2[52].xyzx  // r2.x <- sampleDirection.x
dp3 r2.y, r1.xyzx, cb2[53].xyzx  // r2.y <- sampleDirection.y
dp3 r0.y, r1.xyzx, cb2[54].xyzx  // r0.y <- sampleDirection.z

#line 577
mov r2.z, -r0.y  // r2.z <- sampleDirection.z

#line 462
mul r0.x, r0.x, cb2[51].w  // r0.x <- mipLevel

#line 463
sample_l_indexable(texturecube)(float,float,float,float) r0.xyz, r2.xyzx, t11.xyzw, s1, r0.x  // r0.x <- <Compute_id293 return value>.x; r0.y <- <Compute_id293 return value>.y; r0.z <- <Compute_id293 return value>.z

#line 578
mul r0.xyz, r0.xyzx, cb2[56].xxxx
mul r0.xyz, r0.wwww, r0.xyzx  // r0.x <- streams.envLightSpecularColor_id46.x; r0.y <- streams.envLightSpecularColor_id46.y; r0.z <- streams.envLightSpecularColor_id46.z

#line 846
mad r1.xyz, r4.xyzx, r8.xyzx, r6.xyzx  // r1.x <- environmentLightingContribution.x; r1.y <- environmentLightingContribution.y; r1.z <- environmentLightingContribution.z

#line 850
mad r0.xyz, r5.xyzx, r0.xyzx, r1.xyzx  // r0.x <- environmentLightingContribution.x; r0.y <- environmentLightingContribution.y; r0.z <- environmentLightingContribution.z

#line 853
mad r0.xyz, r14.xyzx, l(3.141593, 3.141593, 3.141593, 0.000000), r0.xyzx  // r0.x <- streams.shadingColor_id71.x; r0.y <- streams.shadingColor_id71.y; r0.z <- streams.shadingColor_id71.z

#line 762
mad r3.xyz, r7.xyzx, cb1[7].zzzz, r0.xyzx  // r3.x <- streams.shadingColor_id71.x; r3.y <- streams.shadingColor_id71.y; r3.z <- streams.shadingColor_id71.z

#line 1116
mad r0.xyz, v6.xyzx, cb0[26].wwww, cb0[26].xyzx  // r0.x <- noiseSamplePosition.x; r0.y <- noiseSamplePosition.y; r0.z <- noiseSamplePosition.z

#line 1067
mov r1.xyz, r0.xyzx  // r1.x <- sampleCoordinates.x; r1.y <- sampleCoordinates.y; r1.z <- sampleCoordinates.z
mov r0.w, l(0)  // r0.w <- noiseSum
mov r1.w, l(1.000000)  // r1.w <- amplitude
mov r2.x, l(0)  // r2.x <- i
loop 
  itof r2.y, r2.x
  ge r2.y, r2.y, l(9.000000)
  breakc_nz r2.y

#line 757
  sample_indexable(texture3d)(float,float,float,float) r2.y, r1.xyzx, t0.yxzw, s0  // r2.y <- value

#line 758
  add r2.y, r2.y, l(-0.500000)
  add r2.y, r2.y, r2.y  // r2.y <- <SampleNoiseCoarse3D_id56 return value>

#line 1069
  mad r0.w, r1.w, |r2.y|, r0.w

#line 1071
  mul r1.w, r1.w, l(0.870000)

#line 1072
  add r1.xyz, r1.xyzx, r1.xyzx

#line 1073
  iadd r2.x, r2.x, l(1)
endloop 

#line 1118
mul r1.xyz, r0.xyzx, l(5.000000, 5.000000, 5.000000, 0.000000)

#line 955
mov r2.xyz, r1.xyzx  // r2.x <- sampleCoordinates.x; r2.y <- sampleCoordinates.y; r2.z <- sampleCoordinates.z
mov r1.w, l(0)  // r1.w <- noiseSum
mov r2.w, l(1.000000)  // r2.w <- amplitude
mov r4.x, l(0)  // r4.x <- i
loop 
  itof r4.y, r4.x
  ge r4.y, r4.y, l(9.000000)
  breakc_nz r4.y

#line 757
  sample_indexable(texture3d)(float,float,float,float) r4.y, r2.xyzx, t0.yxzw, s0  // r4.y <- value

#line 758
  add r4.y, r4.y, l(-0.500000)

#line 957
  dp2 r4.y, r4.yyyy, r2.wwww
  add r1.w, r1.w, r4.y

#line 959
  mul r2.w, r2.w, l(0.830000)

#line 960
  add r2.xyz, r2.xyzx, r2.xyzx

#line 961
  iadd r4.x, r4.x, l(1)
endloop 

#line 1124
lt r1.x, cb0[27].z, l(1.000000)
if_nz r1.x

#line 1126
  mul r1.xyz, r0.xyzx, l(800.000000, 200.000000, 800.000000, 0.000000)
  round_ne r1.xyz, r1.xyzx
  mul r1.xyz, r1.xyzx, l(0.001250, 0.005000, 0.001250, 0.000000)  // r1.x <- constructionNoiseSamplePosition.x; r1.y <- constructionNoiseSamplePosition.y; r1.z <- constructionNoiseSamplePosition.z

#line 955
  mov r2.xyz, r1.xyzx  // r2.x <- sampleCoordinates.x; r2.y <- sampleCoordinates.y; r2.z <- sampleCoordinates.z
  mov r2.w, l(0)  // r2.w <- noiseSum
  mov r4.xy, l(1.000000,0,0,0)  // r4.x <- amplitude; r4.y <- i
  loop 
    itof r4.z, r4.y
    ge r4.z, r4.z, l(9.000000)
    breakc_nz r4.z

#line 757
    sample_indexable(texture3d)(float,float,float,float) r4.z, r2.xyzx, t0.yzxw, s0  // r4.z <- value

#line 758
    add r4.z, r4.z, l(-0.500000)

#line 957
    dp2 r4.z, r4.zzzz, r4.xxxx
    add r2.w, r2.w, r4.z

#line 959
    mul r4.x, r4.x, l(0.710000)

#line 960
    add r2.xyz, r2.xyzx, r2.xyzx

#line 961
    iadd r4.y, r4.y, l(1)
  endloop 

#line 1128
  mad r1.x, r2.w, l(0.303935), l(1.000000)
  mul r1.x, r1.x, l(0.500000)  // r1.x <- constructionNoise

#line 1130
  mad r1.y, cb0[27].z, l(0.230000), l(0.470000)  // r1.y <- constructionThreshold

#line 1131
  lt r1.x, r1.y, r1.x
  if_nz r1.x

#line 1133
    mul r1.xyz, r0.xyzx, l(4000.000000, 750.000000, 4000.000000, 0.000000)
    round_ne r1.xyz, r1.xyzx
    mul r1.xyz, r1.xyzx, l(0.000250, 0.001333, 0.000250, 0.000000)  // r1.x <- constructionNoiseSamplePosition.x; r1.y <- constructionNoiseSamplePosition.y; r1.z <- constructionNoiseSamplePosition.z

#line 967
    dp3 r1.x, r1.xyzx, l(12.989800, 78.233002, 53.987000, 0.000000)
    sincos r1.x, null, r1.x
    mul r1.x, r1.x, l(43758.546875)
    frc r1.x, r1.x  // r1.x <- <RandomValue_id48 return value>

#line 1050
    mad r1.y, -r1.x, l(0.030000), l(0.018500)  // r1.y <- internalColorLevel

#line 1051
    max r1.y, r1.y, l(0.000000)

#line 1053
    mul r2.xyz, |r0.xyzx|, l(166.666672, 166.666672, 166.666672, 0.000000)
    frc r2.xyz, r2.xyzx
    lt r2.xyz, r2.xyzx, l(0.150000, 0.150000, 0.075000, 0.000000)
    or r1.z, r2.y, r2.x
    or r1.z, r2.z, r1.z

#line 1056
    mad r2.xyz, r1.xxxx, l(0.020000, 0.020000, 0.020000, 0.000000), l(0.020000, 0.020000, 0.025000, 0.000000)  // r2.y <- finalColor.x; r2.z <- finalColor.z

#line 1057
    movc r3.xyz, r1.zzzz, r2.xyzx, r1.yyyy  // r3.y <- finalColor.x; r3.z <- finalColor.z
    mov r3.w, l(1.000000)  // r3.w <- finalColor.w

#line 1135
  endif   // r3.x <- finalColor.x; r3.y <- finalColor.y; r3.z <- finalColor.z; r3.w <- finalColor.w

#line 1136
endif 

#line 1137
lt r1.x, l(0.000000), cb0[27].x
if_nz r1.x

#line 1119
  mul r1.x, r1.w, l(0.068999)
  mad r0.w, r0.w, l(0.181957), r1.x  // r0.w <- pixelDamageLevel

#line 1120
  mad r1.x, -cb0[27].x, l(0.300000), l(0.320000)  // r1.x <- damageThreshold

#line 1121
  add r0.w, r0.w, -r1.x
  add r1.x, -r1.x, l(1.000000)
  div r1.x, l(1.000000, 1.000000, 1.000000, 1.000000), r1.x
  mul r0.w, r0.w, r1.x
  max r0.w, r0.w, l(0.000000)  // r0.w <- pixelDamageLevel

#line 1122
  mad r1.x, cb0[27].x, l(0.003000), l(1.000000)
  div_sat r1.x, l(0.350000), r1.x  // r1.x <- fireThreshold

#line 1139
  lt r1.y, r1.x, r0.w
  if_nz r1.y

#line 1141
    add r1.y, r0.w, -r1.x
    add r1.z, -r1.x, l(1.000000)
    div r1.z, l(1.000000, 1.000000, 1.000000, 1.000000), r1.z
    mul r1.y, r1.z, r1.y
    max r1.y, r1.y, l(0.000000)  // r1.y <- fireDamage

#line 1142
    mul r1.z, cb0[27].w, l(13.000000)
    ge r1.z, r1.z, -r1.z
    movc r1.zw, r1.zzzz, l(0,0,13.000000,0.076923), l(0,0,-13.000000,-0.076923)
    mul r1.w, r1.w, cb0[27].w
    frc r1.w, r1.w
    mul r1.z, r1.w, r1.z
    mul r2.z, r1.z, l(0.076923)  // r2.z <- noiseOffset

#line 1143
    mov r2.xy, l(0,0,0,0)
    add r2.xyz, -r2.xyzx, v6.xyzx  // r2.x <- fireNoiseSamplePosition.x; r2.y <- fireNoiseSamplePosition.y; r2.z <- fireNoiseSamplePosition.z

#line 757
    sample_indexable(texture3d)(float,float,float,float) r1.z, r2.xyzx, t0.yzxw, s0  // r1.z <- value

#line 758
    add r1.z, r1.z, l(-0.500000)
    add r1.z, r1.z, r1.z  // r1.z <- <SampleNoiseCoarse3D_id56 return value>

#line 960
    add r4.xyz, r2.xyzx, r2.xyzx  // r4.x <- sampleCoordinates.x; r4.y <- sampleCoordinates.y; r4.z <- sampleCoordinates.z

#line 757
    sample_indexable(texture3d)(float,float,float,float) r1.w, r4.xyzx, t0.yzwx, s0  // r1.w <- value

#line 758
    add r1.w, r1.w, l(-0.500000)

#line 957
    mad r1.z, r1.w, l(1.460000), r1.z  // r1.z <- noiseSum

#line 960
    mul r4.xyz, r2.xyzx, l(4.000000, 4.000000, 4.000000, 0.000000)

#line 757
    sample_indexable(texture3d)(float,float,float,float) r1.w, r4.xyzx, t0.yzwx, s0  // r1.w <- value

#line 758
    add r1.w, r1.w, l(-0.500000)

#line 957
    mad r1.z, r1.w, l(1.065800), r1.z

#line 960
    mul r4.xyz, r2.xyzx, l(8.000000, 8.000000, 8.000000, 0.000000)

#line 757
    sample_indexable(texture3d)(float,float,float,float) r1.w, r4.xyzx, t0.yzwx, s0  // r1.w <- value

#line 758
    add r1.w, r1.w, l(-0.500000)

#line 957
    mad r1.z, r1.w, l(0.778034), r1.z

#line 960
    mul r4.xyz, r2.xyzx, l(16.000000, 16.000000, 16.000000, 0.000000)

#line 757
    sample_indexable(texture3d)(float,float,float,float) r1.w, r4.xyzx, t0.yzwx, s0  // r1.w <- value

#line 758
    add r1.w, r1.w, l(-0.500000)

#line 957
    mad r1.z, r1.w, l(0.567965), r1.z

#line 960
    mul r4.xyz, r2.xyzx, l(32.000000, 32.000000, 32.000000, 0.000000)

#line 757
    sample_indexable(texture3d)(float,float,float,float) r1.w, r4.xyzx, t0.yzwx, s0  // r1.w <- value

#line 758
    add r1.w, r1.w, l(-0.500000)

#line 957
    mad r1.z, r1.w, l(0.414614), r1.z

#line 960
    mul r2.xyz, r2.xyzx, l(64.000000, 64.000000, 64.000000, 0.000000)  // r2.x <- sampleCoordinates.x; r2.y <- sampleCoordinates.y; r2.z <- sampleCoordinates.z

#line 757
    sample_indexable(texture3d)(float,float,float,float) r1.w, r2.xyzx, t0.yzwx, s0  // r1.w <- value

#line 758
    add r1.w, r1.w, l(-0.500000)

#line 957
    mad r1.z, r1.w, l(0.302669), r1.z

#line 962
    mul r1.z, r1.z, l(0.303532)

#line 1145
    mad_sat r2.xyz, r1.zzzz, cb0[29].xyzx, cb0[28].xyzx  // r2.x <- fireColorLow.x; r2.y <- fireColorLow.y; r2.z <- fireColorLow.z

#line 1147
    mul r4.xyz, r0.xyzx, l(800.000000, 200.000000, 800.000000, 0.000000)
    round_ne r4.xyz, r4.xyzx
    mul r4.xyz, r4.xyzx, l(0.001250, 0.005000, 0.001250, 0.000000)  // r4.x <- constructionNoiseSamplePosition.x; r4.y <- constructionNoiseSamplePosition.y; r4.z <- constructionNoiseSamplePosition.z

#line 967
    dp3 r1.z, r4.xyzx, l(12.989800, 78.233002, 53.987000, 0.000000)
    sincos r1.z, null, r1.z
    mul r1.z, r1.z, l(43758.546875)
    frc r1.z, r1.z  // r1.z <- <RandomValue_id48 return value>

#line 757
    sample_indexable(texture3d)(float,float,float,float) r1.w, r0.xyzx, t0.yzwx, s0  // r1.w <- value

#line 758
    add r1.w, r1.w, l(-0.500000)
    add r1.w, r1.w, r1.w  // r1.w <- <SampleNoiseCoarse3D_id56 return value>

#line 960
    add r4.xyz, r0.xyzx, r0.xyzx  // r4.x <- sampleCoordinates.x; r4.y <- sampleCoordinates.y; r4.z <- sampleCoordinates.z

#line 757
    sample_indexable(texture3d)(float,float,float,float) r2.w, r4.xyzx, t0.yzwx, s0  // r2.w <- value

#line 758
    add r2.w, r2.w, l(-0.500000)

#line 957
    mad r1.w, r2.w, l(1.740000), r1.w  // r1.w <- noiseSum

#line 960
    mul r4.xyz, r0.xyzx, l(4.000000, 4.000000, 4.000000, 0.000000)

#line 757
    sample_indexable(texture3d)(float,float,float,float) r2.w, r4.xyzx, t0.yzwx, s0  // r2.w <- value

#line 758
    add r2.w, r2.w, l(-0.500000)

#line 957
    mad r1.w, r2.w, l(1.513800), r1.w

#line 960
    mul r4.xyz, r0.xyzx, l(8.000000, 8.000000, 8.000000, 0.000000)

#line 757
    sample_indexable(texture3d)(float,float,float,float) r2.w, r4.xyzx, t0.yzwx, s0  // r2.w <- value

#line 758
    add r2.w, r2.w, l(-0.500000)

#line 957
    mad r1.w, r2.w, l(1.317006), r1.w

#line 1049
    mad r0.xyz, r1.wwww, l(0.003044, 0.003044, 0.003044, 0.000000), r0.xyzx  // r0.x <- rawNoiseSamplePosition.x; r0.y <- rawNoiseSamplePosition.y; r0.z <- rawNoiseSamplePosition.z

#line 1050
    mad r1.w, -r1.z, l(0.030000), l(0.018500)  // r1.w <- internalColorLevel

#line 1051
    max r1.w, r1.w, l(0.000000)

#line 1053
    mul r4.xyz, |r0.xyzx|, l(0.006000, 0.006000, 0.006000, 0.000000)
    ge r4.xyz, r4.xyzx, -r4.xyzx
    movc r5.xyzw, r4.xxyy, l(0.006000,166.666672,0.006000,166.666672), l(-0.006000,-166.666672,-0.006000,-166.666672)
    mul r0.xy, |r0.xyxx|, r5.ywyy
    frc r0.xy, r0.xyxx
    mul r0.xy, r0.xyxx, r5.xzxx
    lt r0.xy, r0.xyxx, l(0.000900, 0.000900, 0.000000, 0.000000)
    or r0.x, r0.y, r0.x
    movc r4.xy, r4.zzzz, l(0.006000,166.666672,0,0), l(-0.006000,-166.666672,0,0)
    mul r0.y, |r0.z|, r4.y
    frc r0.y, r0.y
    mul r0.y, r0.y, r4.x
    lt r0.y, r0.y, l(0.000450)
    or r0.x, r0.y, r0.x

#line 1056
    mad r4.xyz, r1.zzzz, l(0.020000, 0.020000, 0.020000, 0.000000), l(0.020000, 0.020000, 0.025000, 0.000000)  // r4.y <- finalColor.x; r4.z <- finalColor.z

#line 1057
    movc r0.xyz, r0.xxxx, r4.xyzx, r1.wwww  // r0.y <- finalColor.x; r0.z <- finalColor.z

#line 1149
    add r4.xyz, -r2.xyzx, r0.yyzy
    mad r2.xyz, r4.xyzx, l(0.200000, 0.200000, 0.200000, 0.000000), r2.xyzx  // r2.x <- fireColorLowFinal.x; r2.y <- fireColorLowFinal.y; r2.z <- fireColorLowFinal.z

#line 1151
    add r0.xyz, r0.xyzx, -r2.xyzx
    mad r0.xyz, r1.yyyy, r0.xyzx, r2.xyzx  // r0.x <- fireColor.x; r0.y <- fireColor.y; r0.z <- fireColor.z

#line 1153
  else   // Prior locations: r0.x <- noiseSamplePosition.x; r0.y <- noiseSamplePosition.y; r0.z <- noiseSamplePosition.z

#line 1156
    mul r0.w, r0.w, l(1.700000)
    div r1.x, l(1.000000, 1.000000, 1.000000, 1.000000), r1.x
    mul r0.w, r0.w, r1.x
    min r0.w, r0.w, l(1.000000)
    mad r0.xyz, r0.wwww, -r3.xyzx, r3.xyzx

#line 1158
  endif 

#line 1159
  mov o0.xyz, r0.xyzx
  mov o0.w, l(1.000000)
else   // Prior locations: r3.x <- finalColor.x; r3.y <- finalColor.y; r3.z <- finalColor.z; r3.w <- finalColor.w; r0.x <- noiseSamplePosition.x; r0.y <- noiseSamplePosition.y; r0.z <- noiseSamplePosition.z
  mov o0.xyzw, r3.xyzw  // o0.x <- finalColor.x; o0.y <- finalColor.y; o0.z <- finalColor.z; o0.w <- finalColor.w
endif 

#line 1228
ret 
// Approximately 502 instruction slots used
***************************
*************************/
const static int TOrder_id125 = 5;
const static int TOrder_id127 = 5;
const static bool TIsNormalXY1_id203 = true;
const static bool TScaleAndBias_id204 = true;
const static bool TInvert_id210 = false;
const static bool TIsEnergyConservative_id241 = true;
static const float PI_id243 = 3.14159265358979323846;
const static bool TUseAlphaFromEmissive_id253 = false;
struct PS_STREAMS 
{
    float4 ScreenPosition_id108;
    float3 meshNormal_id15;
    float4 meshTangent_id17;
    float4 PositionWS_id21;
    float2 TexCoord_id177;
    float4 ShadingPosition_id0;
    float4 Position_id20;
    bool IsFrontFace_id1;
    float3x3 tangentToWorld_id19;
    float3 meshNormalWS_id16;
    float3 viewWS_id66;
    float3 shadingColor_id71;
    float matBlend_id39;
    float3 matNormal_id49;
    float4 matColorBase_id50;
    float4 matDiffuse_id51;
    float3 matDiffuseVisible_id67;
    float3 matSpecular_id53;
    float3 matSpecularVisible_id69;
    float matSpecularIntensity_id54;
    float matGlossiness_id52;
    float alphaRoughness_id68;
    float matAmbientOcclusion_id55;
    float matAmbientOcclusionDirectLightingFactor_id56;
    float matCavity_id57;
    float matCavityDiffuse_id58;
    float matCavitySpecular_id59;
    float4 matEmissive_id60;
    float matEmissiveIntensity_id61;
    float matScatteringStrength_id62;
    float2 matDiffuseSpecularAlphaBlend_id63;
    float3 matAlphaBlendColor_id64;
    float matAlphaDiscard_id65;
    float shadingColorAlpha_id72;
    float3 normalWS_id18;
    float3 lightPositionWS_id40;
    float3 lightDirectionWS_id41;
    float3 lightColor_id42;
    float3 lightColorNdotL_id43;
    float3 lightSpecularColorNdotL_id44;
    float3 envLightDiffuseColor_id45;
    float3 envLightSpecularColor_id46;
    float lightDirectAmbientOcclusion_id48;
    float NdotL_id47;
    float NdotV_id70;
    uint2 lightData_id114;
    int lightIndex_id115;
    float thicknessWS_id107;
    float3 shadowColor_id106;
    float3 H_id73;
    float NdotH_id74;
    float LdotH_id75;
    float VdotH_id76;
    float4 ColorTarget_id2;
};
struct PS_OUTPUT 
{
    float4 ColorTarget_id2 : SV_Target0;
};
struct PS_INPUT 
{
    float4 PositionWS_id21 : POSITION_WS;
    float4 ShadingPosition_id0 : SV_Position;
    float4 ScreenPosition_id108 : SCREENPOSITION_ID108_SEM;
    float3 meshNormal_id15 : NORMAL;
    float4 meshTangent_id17 : TANGENT;
    float2 TexCoord_id177 : TEXCOORD0;
    float4 Position_id20 : POSITION;
    bool IsFrontFace_id1 : SV_IsFrontFace;
};
struct VS_STREAMS 
{
    float4 Position_id20;
    float3 meshNormal_id15;
    float4 meshTangent_id17;
    float2 TexCoord_id177;
    float4 PositionH_id23;
    float DepthVS_id22;
    float3 normalWS_id18;
    float4 PositionWS_id21;
    float4 ShadingPosition_id0;
    float4 ScreenPosition_id108;
};
struct VS_OUTPUT 
{
    float4 PositionWS_id21 : POSITION_WS;
    float4 ShadingPosition_id0 : SV_Position;
    float4 ScreenPosition_id108 : SCREENPOSITION_ID108_SEM;
    float3 meshNormal_id15 : NORMAL;
    float4 meshTangent_id17 : TANGENT;
    float2 TexCoord_id177 : TEXCOORD0;
    float4 Position_id20 : POSITION;
};
struct VS_INPUT 
{
    float4 Position_id20 : POSITION;
    float3 meshNormal_id15 : NORMAL;
    float4 meshTangent_id17 : TANGENT;
    float2 TexCoord_id177 : TEXCOORD0;
};
struct PointLightData 
{
    float3 PositionWS;
    float InvSquareRadius;
    float3 Color;
};
struct PointLightDataInternal 
{
    float3 PositionWS;
    float InvSquareRadius;
    float3 Color;
};
struct SpotLightDataInternal 
{
    float3 PositionWS;
    float3 DirectionWS;
    float3 AngleOffsetAndInvSquareRadius;
    float3 Color;
};
struct SpotLightData 
{
    float3 PositionWS;
    float3 DirectionWS;
    float3 AngleOffsetAndInvSquareRadius;
    float3 Color;
};
cbuffer PerDraw 
{
    float4x4 World_id31;
    float4x4 WorldInverse_id32;
    float4x4 WorldInverseTranspose_id33;
    float4x4 WorldView_id34;
    float4x4 WorldViewInverse_id35;
    float4x4 WorldViewProjection_id36;
    float3 WorldScale_id37;
    float4 EyeMS_id38;
    float3 DW_NoiseOffset_id96 = float3(0, 0, 0);
    float DW_NoiseScale_id97 = 10.0f;
    float DW_DamageLevel_id98 = 0;
    float DW_NoiseOffsetFactor_id99 = 1;
    float DW_ConstructionLevel_id100 = 1;
    float DW_TimeValue_id101;
    float4 DW_NoiseColorLow_id102 = float4(0.5f, 0, 0, 1);
    float4 DW_NoiseColorLowAdd_id103 = float4(1.2f, 0.6f, 0, 1);
    float4 DW_NoiseColorHigh_id104 = float4(1, 1, 0, 1);
    float4 DW_NoiseColorHighAdd_id105 = float4(2.8f, 2.0f, 1.9f, 1);
};
cbuffer PerMaterial 
{
    float2 scale_id196;
    float2 offset_id197;
    float2 scale_id201;
    float2 offset_id202;
    float2 scale_id208;
    float2 offset_id209;
    float4 constantColor_id215;
    float constantFloat_id217;
    float2 scale_id221;
    float2 offset_id222;
    float constantFloat_id224;
    float constantFloat_id226;
    float constantFloat_id228;
    float constantFloat_id230;
    float2 scale_id234;
    float2 offset_id235;
    float constantFloat_id237;
};
cbuffer PerView 
{
    float4x4 View_id24;
    float4x4 ViewInverse_id25;
    float4x4 Projection_id26;
    float4x4 ProjectionInverse_id27;
    float4x4 ViewProjection_id28;
    float2 ProjScreenRay_id29;
    float4 Eye_id30;
    float NearClipPlane_id109 = 1.0f;
    float FarClipPlane_id110 = 100.0f;
    float2 ZProjection_id111;
    float2 ViewSize_id112;
    float AspectRatio_id113;
    float4 _padding_PerView_Default;
    float ClusterDepthScale_id118;
    float ClusterDepthBias_id119;
    float2 ClusterStride_id120;
    float3 AmbientLight_id123;
    float3 SphericalColors_id128[TOrder_id127 * TOrder_id127];
    float MipCount_id187;
    float4x4 SkyMatrix_id189;
    float Intensity_id190;
    float4 _padding_PerView_Lighting;
};
cbuffer Globals 
{
    float2 Texture0TexelSize_id130;
    float2 Texture1TexelSize_id132;
    float2 Texture2TexelSize_id134;
    float2 Texture3TexelSize_id136;
    float2 Texture4TexelSize_id138;
    float2 Texture5TexelSize_id140;
    float2 Texture6TexelSize_id142;
    float2 Texture7TexelSize_id144;
    float2 Texture8TexelSize_id146;
    float2 Texture9TexelSize_id148;
};
Texture3D NoiseTextureCoarse3D_id84;
SamplerState NoiseTextureCoarse3DSampler_id85;
Texture3D NoiseTextureFine3D_id86;
SamplerState NoiseTextureFine3DSampler_id87;
Texture3D NoiseTextureVeryFine3D_id88;
SamplerState NoiseTextureVeryFine3DSampler_id89;
Texture2D NoiseTextureFine_id90;
SamplerState NoiseTextureFineSampler_id91;
Texture2D NoiseTextureCoarse_id92;
SamplerState NoiseTextureCoarseSampler_id93;
Texture2D NoiseTextureVeryFine_id94;
SamplerState NoiseTextureVeryFineSampler_id95;
Texture2D Texture0_id129;
Texture2D Texture1_id131;
Texture2D Texture2_id133;
Texture2D Texture3_id135;
Texture2D Texture4_id137;
Texture2D Texture5_id139;
Texture2D Texture6_id141;
Texture2D Texture7_id143;
Texture2D Texture8_id145;
Texture2D Texture9_id147;
TextureCube TextureCube0_id149;
TextureCube TextureCube1_id150;
TextureCube TextureCube2_id151;
TextureCube TextureCube3_id152;
Texture3D Texture3D0_id153;
Texture3D Texture3D1_id154;
Texture3D Texture3D2_id155;
Texture3D Texture3D3_id156;
SamplerState Sampler_id157;
SamplerState PointSampler_id158 
{
    Filter = MIN_MAG_MIP_POINT;
};
SamplerState LinearSampler_id159 
{
    Filter = MIN_MAG_MIP_LINEAR;
};
SamplerState LinearBorderSampler_id160 
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Border;
    AddressV = Border;
};
SamplerComparisonState LinearClampCompareLessEqualSampler_id161 
{
    Filter = COMPARISON_MIN_MAG_LINEAR_MIP_POINT;
    AddressU = Clamp;
    AddressV = Clamp;
    ComparisonFunc = LessEqual;
};
SamplerState AnisotropicSampler_id162 
{
    Filter = ANISOTROPIC;
};
SamplerState AnisotropicRepeatSampler_id163 
{
    Filter = ANISOTROPIC;
    AddressU = Wrap;
    AddressV = Wrap;
    MaxAnisotropy = 16;
};
SamplerState PointRepeatSampler_id164 
{
    Filter = MIN_MAG_MIP_POINT;
    AddressU = Wrap;
    AddressV = Wrap;
};
SamplerState LinearRepeatSampler_id165 
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Wrap;
    AddressV = Wrap;
};
SamplerState RepeatSampler_id166 
{
    AddressU = Wrap;
    AddressV = Wrap;
};
SamplerState Sampler0_id167;
SamplerState Sampler1_id168;
SamplerState Sampler2_id169;
SamplerState Sampler3_id170;
SamplerState Sampler4_id171;
SamplerState Sampler5_id172;
SamplerState Sampler6_id173;
SamplerState Sampler7_id174;
SamplerState Sampler8_id175;
SamplerState Sampler9_id176;
Texture2D Texture_id193;
SamplerState Sampler_id194;
Texture2D Texture_id199;
Texture2D Texture_id206;
Texture2D Texture_id219;
Texture2D Texture_id232;
Texture2D EnvironmentLightingDFG_LUT_id244;
Texture3D<uint2> LightClusters_id116;
Buffer<uint> LightIndices_id117;
Buffer<float4> PointLights_id121;
Buffer<float4> SpotLights_id122;
TextureCube CubeMap_id188;
float SmoothDistanceAttenuation_id117(float squaredDistance, float lightInvSquareRadius)
{
    float factor = squaredDistance * lightInvSquareRadius;
    float smoothFactor = saturate(1.0f - factor * factor);
    return smoothFactor * smoothFactor;
}
float SmoothDistanceAttenuation_id106(float squaredDistance, float lightInvSquareRadius)
{
    float factor = squaredDistance * lightInvSquareRadius;
    float smoothFactor = saturate(1.0f - factor * factor);
    return smoothFactor * smoothFactor;
}
float GetAngularAttenuation_id119(float3 lightVector, float3 lightDirection, float lightAngleScale, float lightAngleOffset)
{
    float cd = dot(lightDirection, lightVector);
    float attenuation = saturate(cd * lightAngleScale + lightAngleOffset);
    attenuation *= attenuation;
    return attenuation;
}
float GetDistanceAttenuation_id118(float lightVectorLength, float lightInvSquareRadius)
{
    float d2 = lightVectorLength * lightVectorLength;
    float attenuation = 1.0 / (max(d2, 0.01 * 0.01));
    attenuation *= SmoothDistanceAttenuation_id117(d2, lightInvSquareRadius);
    return attenuation;
}
float GetDistanceAttenuation_id108(float lightVectorLength, float lightInvSquareRadius)
{
    float d2 = lightVectorLength * lightVectorLength;
    float attenuation = 1.0 / (max(d2, 0.01 * 0.01));
    attenuation *= SmoothDistanceAttenuation_id106(d2, lightInvSquareRadius);
    return attenuation;
}
float ComputeAttenuation_id120(float3 PositionWS, float3 AngleOffsetAndInvSquareRadius, float3 DirectionWS, float3 position, inout float3 lightVectorNorm)
{
    float3 lightVector = PositionWS - position;
    float lightVectorLength = length(lightVector);
    lightVectorNorm = lightVector / lightVectorLength;
    float3 lightAngleOffsetAndInvSquareRadius = AngleOffsetAndInvSquareRadius;
    float2 lightAngleAndOffset = lightAngleOffsetAndInvSquareRadius.xy;
    float lightInvSquareRadius = lightAngleOffsetAndInvSquareRadius.z;
    float3 lightDirection = -DirectionWS;
    float attenuation = GetDistanceAttenuation_id118(lightVectorLength, lightInvSquareRadius);
    attenuation *= GetAngularAttenuation_id119(lightVectorNorm, lightDirection, lightAngleAndOffset.x, lightAngleAndOffset.y);
    return attenuation;
}
float ClampedPow_id234(float x, float y)
{
    return pow(max(x, 0.00001f), y);
}
float3 FresnelSchlick_id212(float3 f0, float3 f90, float lOrVDotH)
{
    return f0 + (f90 - f0) * pow((1 - lOrVDotH), 5);
}
float ComputeAttenuation_id107(PointLightDataInternal light, float3 position, inout float3 lightVectorNorm)
{
    float3 lightVector = light.PositionWS - position;
    float lightVectorLength = length(lightVector);
    lightVectorNorm = lightVector / lightVectorLength;
    float lightInvSquareRadius = light.InvSquareRadius;
    return GetDistanceAttenuation_id108(lightVectorLength, lightInvSquareRadius);
}
float4 EvaluateSphericalHarmonics_id130(float3 sphericalColors[TOrder_id125 * TOrder_id125], float3 direction)
{
    float x = direction.x;
    float y = direction.y;
    float z = direction.z;
    float x2 = x * x;
    float y2 = y * y;
    float z2 = z * z;
    float3 color = sphericalColors[0];

    {
        color += sphericalColors[1] * y;
        color += sphericalColors[2] * z;
        color += sphericalColors[3] * x;

        {
            color += sphericalColors[4] * y * x;
            color += sphericalColors[5] * y * z;
            color += sphericalColors[6] * (3.0 * z2 - 1.0);
            color += sphericalColors[7] * x * z;
            color += sphericalColors[8] * (x2 - y2);

            {
                float z3 = z2 * z;
                float x4 = x2 * x2;
                float y4 = y2 * y2;
                float z4 = z2 * z2;
                color += sphericalColors[9] * y * (3 * x2 - y2);
                color += sphericalColors[10] * y * x * z;
                color += sphericalColors[11] * y * (-1.0 + 5.0 * z2);
                color += sphericalColors[12] * (5.0 * z3 - 3.0 * z);
                color += sphericalColors[13] * x * (-1.0 + 5.0 * z2);
                color += sphericalColors[14] * (x2 - y2) * z;
                color += sphericalColors[15] * x * (x2 - 3.0 * y2);

                {
                    color += sphericalColors[16] * x * y * (x2 - y2);
                    color += sphericalColors[17] * y * z * (3.0 * x2 - y2);
                    color += sphericalColors[18] * y * x * (-1.0 + 7.0 * z2);
                    color += sphericalColors[19] * y * z * (-3.0 + 7.0 * z2);
                    color += sphericalColors[20] * (105.0 * z4 - 90.0 * z2 + 9.0);
                    color += sphericalColors[21] * x * z * (-3.0 + 7.0 * z2);
                    color += sphericalColors[22] * (x2 - y2) * (-1.0 + 7.0 * z2);
                    color += sphericalColors[23] * x * z * (x2 - 3.0 * y2);
                    color += sphericalColors[24] * (x4 - 6.0 * y2 * x2 + y4);
                }
            }
        }
    }
    return float4(color, 1);
}
void ProcessLight_id121(inout PS_STREAMS streams, SpotLightDataInternal light)
{
    float3 lightVectorNorm;
    float attenuation = ComputeAttenuation_id120(light.PositionWS, light.AngleOffsetAndInvSquareRadius, light.DirectionWS, streams.PositionWS_id21.xyz, lightVectorNorm);
    streams.lightColor_id42 = light.Color * attenuation;
    streams.lightDirectionWS_id41 = lightVectorNorm;
}
float NormalDistributionBlinnPhong_id240(float alphaR, float nDotH)
{
    float alphaR2 = max(alphaR * alphaR, 0.1);
    return ClampedPow_id234(nDotH, 2 / alphaR2 - 2) / (PI_id243 * alphaR2);
}
float VisibilityImplicit_id229(float nDotL, float nDotV)
{
    return 1.0f;
}
float3 FresnelSchlick_id218(float3 f0, float lOrVDotH)
{
    return FresnelSchlick_id212(f0, 1.0f, lOrVDotH);
}
void ProcessLight_id110(inout PS_STREAMS streams, PointLightDataInternal light)
{
    float3 lightVectorNorm;
    float attenuation = ComputeAttenuation_id107(light, streams.PositionWS_id21.xyz, lightVectorNorm);
    streams.lightPositionWS_id40 = light.PositionWS;
    streams.lightColor_id42 = light.Color * attenuation;
    streams.lightDirectionWS_id41 = lightVectorNorm;
}
float4 Compute_id293(inout PS_STREAMS streams, float3 direction)
{
    float alpha = streams.alphaRoughness_id68;
    float mipLevel = sqrt(alpha) * MipCount_id187;
    return CubeMap_id188.SampleLevel(LinearSampler_id159, direction, mipLevel);
}
float4 Compute_id288(float3 direction)
{
    return EvaluateSphericalHarmonics_id130(SphericalColors_id128, direction);
}
void PrepareEnvironmentLight_id134(inout PS_STREAMS streams)
{
    streams.envLightDiffuseColor_id45 = 0;
    streams.envLightSpecularColor_id46 = 0;
}
float3 Compute_id328(float3 specularColor, float alphaR, float nDotV)
{
    float glossiness = 1.0f - sqrt(alphaR);
    float4 environmentLightingDFG = EnvironmentLightingDFG_LUT_id244.SampleLevel(LinearSampler_id159, float2(glossiness, nDotV), 0);
    return specularColor * environmentLightingDFG.r + environmentLightingDFG.g;
}
void PrepareEnvironmentLight_id125(inout PS_STREAMS streams)
{
    streams.envLightDiffuseColor_id45 = 0;
    streams.envLightSpecularColor_id46 = 0;
}
float3 ComputeSpecularTextureProjection_id116(float3 positionWS, float3 reflectionWS, int lightIndex)
{
    return 1.0f;
}
float3 ComputeTextureProjection_id115(float3 positionWS, int lightIndex)
{
    return 1.0f;
}
float3 ComputeShadow_id114(inout PS_STREAMS streams, float3 position, int lightIndex)
{
    streams.thicknessWS_id107 = 0.0;
    return 1.0f;
}
void PrepareDirectLightCore_id113(inout PS_STREAMS streams, int lightIndexIgnored)
{
    int realLightIndex = LightIndices_id117.Load(streams.lightIndex_id115);
    streams.lightIndex_id115++;
    SpotLightDataInternal spotLight;
    float4 spotLight1 = SpotLights_id122.Load(realLightIndex * 4);
    float4 spotLight2 = SpotLights_id122.Load(realLightIndex * 4 + 1);
    float4 spotLight3 = SpotLights_id122.Load(realLightIndex * 4 + 2);
    float4 spotLight4 = SpotLights_id122.Load(realLightIndex * 4 + 3);
    spotLight.PositionWS = spotLight1.xyz;
    spotLight.DirectionWS = spotLight2.xyz;
    spotLight.AngleOffsetAndInvSquareRadius = spotLight3.xyz;
    spotLight.Color = spotLight4.xyz;
    ProcessLight_id121(streams, spotLight);
}
float Compute_id421(inout PS_STREAMS streams)
{
    return NormalDistributionBlinnPhong_id240(streams.alphaRoughness_id68, streams.NdotH_id74);
}
float Compute_id390(inout PS_STREAMS streams)
{
    return VisibilityImplicit_id229(streams.NdotL_id47, streams.NdotV_id70);
}
float3 Compute_id360(inout PS_STREAMS streams, float3 f0)
{
    return FresnelSchlick_id218(f0, streams.LdotH_id75);
}
float3 ComputeSpecularTextureProjection_id105(float3 positionWS, float3 reflectionWS, int lightIndex)
{
    return 1.0f;
}
float3 ComputeTextureProjection_id104(float3 positionWS, int lightIndex)
{
    return 1.0f;
}
float3 ComputeShadow_id103(inout PS_STREAMS streams, float3 position, int lightIndex)
{
    streams.thicknessWS_id107 = 0.0;
    return 1.0f;
}
void PrepareDirectLightCore_id102(inout PS_STREAMS streams, int lightIndexIgnored)
{
    int realLightIndex = LightIndices_id117.Load(streams.lightIndex_id115);
    streams.lightIndex_id115++;
    PointLightDataInternal pointLight;
    float4 pointLight1 = PointLights_id121.Load(realLightIndex * 2);
    float4 pointLight2 = PointLights_id121.Load(realLightIndex * 2 + 1);
    pointLight.PositionWS = pointLight1.xyz;
    pointLight.InvSquareRadius = pointLight1.w;
    pointLight.Color = pointLight2.xyz;
    ProcessLight_id110(streams, pointLight);
}
void PrepareLightData_id109(inout PS_STREAMS streams)
{
    float projectedDepth = streams.ShadingPosition_id0.z;
    float depth = ZProjection_id111.y / (projectedDepth - ZProjection_id111.x);
    float2 texCoord = float2(streams.ScreenPosition_id108.x + 1, 1 - streams.ScreenPosition_id108.y) * 0.5;
    int slice = int(max(log2(depth * ClusterDepthScale_id118 + ClusterDepthBias_id119), 0));
    streams.lightData_id114 = LightClusters_id116.Load(int4(texCoord * ClusterStride_id120, slice, 0));
    streams.lightIndex_id115 = streams.lightData_id114.x;
}
void ResetStream_id246()
{
}
void AfterLightingAndShading_id479()
{
}
void AfterLightingAndShading_id460()
{
}
void PrepareEnvironmentLight_id303(inout PS_STREAMS streams)
{
    PrepareEnvironmentLight_id134(streams);
    float ambientAccessibility = streams.matAmbientOcclusion_id55;
    float3 sampleDirection = mul(streams.normalWS_id18, (float3x3)SkyMatrix_id189);
    sampleDirection = float3(sampleDirection.xy, -sampleDirection.z);
    streams.envLightDiffuseColor_id45 = Compute_id288(sampleDirection).rgb * Intensity_id190 * ambientAccessibility * streams.matDiffuseSpecularAlphaBlend_id63.x;
    sampleDirection = reflect(-streams.viewWS_id66, streams.normalWS_id18);
    sampleDirection = mul(sampleDirection, (float3x3)SkyMatrix_id189);
    sampleDirection = float3(sampleDirection.xy, -sampleDirection.z);
    streams.envLightSpecularColor_id46 = Compute_id293(streams, sampleDirection).rgb * Intensity_id190 * ambientAccessibility * streams.matDiffuseSpecularAlphaBlend_id63.y;
}
float3 ComputeEnvironmentLightContribution_id509(inout PS_STREAMS streams)
{
    float3 specularColor = streams.matSpecularVisible_id69;
    return Compute_id328(specularColor, streams.alphaRoughness_id68, streams.NdotV_id70) * streams.envLightSpecularColor_id46;
}
float3 ComputeEnvironmentLightContribution_id453(inout PS_STREAMS streams)
{
    float3 diffuseColor = streams.matDiffuseVisible_id67;

    {
        diffuseColor *= (1 - streams.matSpecularVisible_id69);
    }
    return diffuseColor * streams.envLightDiffuseColor_id45;
}
void PrepareEnvironmentLight_id298(inout PS_STREAMS streams)
{
    PrepareEnvironmentLight_id125(streams);
    float3 lightColor = AmbientLight_id123 * streams.matAmbientOcclusion_id55;
    streams.envLightDiffuseColor_id45 = lightColor;
    streams.envLightSpecularColor_id46 = lightColor;
}
void PrepareDirectLight_id269(inout PS_STREAMS streams, int lightIndex)
{
    PrepareDirectLightCore_id113(streams, lightIndex);
    streams.NdotL_id47 = max(dot(streams.normalWS_id18, streams.lightDirectionWS_id41), 0.0001f);
    streams.shadowColor_id106 = ComputeShadow_id114(streams, streams.PositionWS_id21.xyz, lightIndex);
    streams.lightColorNdotL_id43 = streams.lightColor_id42 * streams.shadowColor_id106 * streams.NdotL_id47 * streams.lightDirectAmbientOcclusion_id48;
    streams.lightSpecularColorNdotL_id44 = streams.lightColorNdotL_id43;
    streams.lightColorNdotL_id43 *= ComputeTextureProjection_id115(streams.PositionWS_id21.xyz, lightIndex);
    float3 reflectionVectorWS = reflect(-streams.viewWS_id66, streams.normalWS_id18);
    streams.lightSpecularColorNdotL_id44 *= ComputeSpecularTextureProjection_id116(streams.PositionWS_id21.xyz, reflectionVectorWS, lightIndex);
}
int GetLightCount_id273(inout PS_STREAMS streams)
{
    return streams.lightData_id114.y >> 16;
}
int GetMaxLightCount_id272(inout PS_STREAMS streams)
{
    return streams.lightData_id114.y >> 16;
}
void PrepareDirectLights_id267()
{
}
float3 ComputeDirectLightContribution_id508(inout PS_STREAMS streams)
{
    float3 specularColor = streams.matSpecularVisible_id69;
    float3 fresnel = Compute_id360(streams, specularColor);
    float geometricShadowing = Compute_id390(streams);
    float normalDistribution = Compute_id421(streams);
    float3 reflected = fresnel * geometricShadowing * normalDistribution / 4;
    return reflected * streams.lightSpecularColorNdotL_id44 * streams.matDiffuseSpecularAlphaBlend_id63.y;
}
float3 ComputeDirectLightContribution_id452(inout PS_STREAMS streams)
{
    float3 diffuseColor = streams.matDiffuseVisible_id67;

    {
        diffuseColor *= (1 - streams.matSpecularVisible_id69);
    }
    return diffuseColor / PI_id243 * streams.lightColorNdotL_id43 * streams.matDiffuseSpecularAlphaBlend_id63.x;
}
void PrepareMaterialPerDirectLight_id29(inout PS_STREAMS streams)
{
    streams.H_id73 = normalize(streams.viewWS_id66 + streams.lightDirectionWS_id41);
    streams.NdotH_id74 = saturate(dot(streams.normalWS_id18, streams.H_id73));
    streams.LdotH_id75 = saturate(dot(streams.lightDirectionWS_id41, streams.H_id73));
    streams.VdotH_id76 = streams.LdotH_id75;
}
void PrepareDirectLight_id256(inout PS_STREAMS streams, int lightIndex)
{
    PrepareDirectLightCore_id102(streams, lightIndex);
    streams.NdotL_id47 = max(dot(streams.normalWS_id18, streams.lightDirectionWS_id41), 0.0001f);
    streams.shadowColor_id106 = ComputeShadow_id103(streams, streams.PositionWS_id21.xyz, lightIndex);
    streams.lightColorNdotL_id43 = streams.lightColor_id42 * streams.shadowColor_id106 * streams.NdotL_id47 * streams.lightDirectAmbientOcclusion_id48;
    streams.lightSpecularColorNdotL_id44 = streams.lightColorNdotL_id43;
    streams.lightColorNdotL_id43 *= ComputeTextureProjection_id104(streams.PositionWS_id21.xyz, lightIndex);
    float3 reflectionVectorWS = reflect(-streams.viewWS_id66, streams.normalWS_id18);
    streams.lightSpecularColorNdotL_id44 *= ComputeSpecularTextureProjection_id105(streams.PositionWS_id21.xyz, reflectionVectorWS, lightIndex);
}
int GetLightCount_id261(inout PS_STREAMS streams)
{
    return streams.lightData_id114.y & 0xFFFF;
}
int GetMaxLightCount_id260(inout PS_STREAMS streams)
{
    return streams.lightData_id114.y & 0xFFFF;
}
void PrepareDirectLights_id259(inout PS_STREAMS streams)
{
    PrepareLightData_id109(streams);
}
void PrepareForLightingAndShading_id476()
{
}
void PrepareForLightingAndShading_id457()
{
}
void PrepareMaterialForLightingAndShading_id242(inout PS_STREAMS streams)
{
    streams.lightDirectAmbientOcclusion_id48 = lerp(1.0, streams.matAmbientOcclusion_id55, streams.matAmbientOcclusionDirectLightingFactor_id56);
    streams.matDiffuseVisible_id67 = streams.matDiffuse_id51.rgb * lerp(1.0f, streams.matCavity_id57, streams.matCavityDiffuse_id58) * streams.matDiffuseSpecularAlphaBlend_id63.r * streams.matAlphaBlendColor_id64;
    streams.matSpecularVisible_id69 = streams.matSpecular_id53.rgb * streams.matSpecularIntensity_id54 * lerp(1.0f, streams.matCavity_id57, streams.matCavitySpecular_id59) * streams.matDiffuseSpecularAlphaBlend_id63.g * streams.matAlphaBlendColor_id64;
    streams.NdotV_id70 = max(dot(streams.normalWS_id18, streams.viewWS_id66), 0.0001f);
    float roughness = 1.0f - streams.matGlossiness_id52;
    streams.alphaRoughness_id68 = max(roughness * roughness, 0.001);
}
void ResetLightStream_id241(inout PS_STREAMS streams)
{
    streams.lightPositionWS_id40 = 0;
    streams.lightDirectionWS_id41 = 0;
    streams.lightColor_id42 = 0;
    streams.lightColorNdotL_id43 = 0;
    streams.lightSpecularColorNdotL_id44 = 0;
    streams.envLightDiffuseColor_id45 = 0;
    streams.envLightSpecularColor_id46 = 0;
    streams.lightDirectAmbientOcclusion_id48 = 1.0f;
    streams.NdotL_id47 = 0;
}
void UpdateNormalFromTangentSpace_id18(inout PS_STREAMS streams, float3 normalInTangentSpace)
{
    streams.normalWS_id18 = normalize(mul(normalInTangentSpace, streams.tangentToWorld_id19));
}
float4 Compute_id326()
{
    return float4(constantFloat_id237, constantFloat_id237, constantFloat_id237, constantFloat_id237);
}
float4 Compute_id324(inout PS_STREAMS streams)
{
    return Texture_id232.Sample(Sampler_id194, streams.TexCoord_id177 * scale_id234 + offset_id235).rgba;
}
float4 Compute_id322()
{
    return float4(constantFloat_id230, constantFloat_id230, constantFloat_id230, constantFloat_id230);
}
float4 Compute_id320()
{
    return float4(constantFloat_id228, constantFloat_id228, constantFloat_id228, constantFloat_id228);
}
float4 Compute_id318()
{
    return float4(constantFloat_id226, constantFloat_id226, constantFloat_id226, constantFloat_id226);
}
float4 Compute_id316()
{
    return float4(constantFloat_id224, constantFloat_id224, constantFloat_id224, constantFloat_id224);
}
float4 Compute_id314(inout PS_STREAMS streams)
{
    return Texture_id219.Sample(Sampler_id194, streams.TexCoord_id177 * scale_id221 + offset_id222).b;
}
float4 Compute_id312()
{
    return float4(constantFloat_id217, constantFloat_id217, constantFloat_id217, constantFloat_id217);
}
float4 Compute_id310()
{
    return constantColor_id215;
}
float4 Compute_id308(inout PS_STREAMS streams)
{
    return Texture_id206.Sample(Sampler_id194, streams.TexCoord_id177 * scale_id208 + offset_id209).g;
}
float4 Compute_id306(inout PS_STREAMS streams)
{
    return Texture_id199.Sample(Sampler_id194, streams.TexCoord_id177 * scale_id201 + offset_id202).rgba;
}
float4 Compute_id304(inout PS_STREAMS streams)
{
    return Texture_id193.Sample(Sampler_id194, streams.TexCoord_id177 * scale_id196 + offset_id197).rgba;
}
void ResetStream_id247(inout PS_STREAMS streams)
{
    ResetStream_id246();
    streams.matBlend_id39 = 0.0f;
}
float SampleNoiseCoarse3D_id56(float3 coordinates)
{
    float value = NoiseTextureCoarse3D_id84.Sample(NoiseTextureCoarse3DSampler_id85, coordinates);
    return ((value - 0.5) * 2.0);
}
void Compute_id586(inout PS_STREAMS streams)
{
    streams.shadingColor_id71 += streams.matEmissive_id60.rgb * streams.matEmissiveIntensity_id61;
}
void Compute_id585(inout PS_STREAMS streams)
{
    UpdateNormalFromTangentSpace_id18(streams, streams.matNormal_id49);
    if (!streams.IsFrontFace_id1)
        streams.normalWS_id18 = -streams.normalWS_id18;
    ResetLightStream_id241(streams);
    PrepareMaterialForLightingAndShading_id242(streams);

    {
        PrepareForLightingAndShading_id457();
    }

    {
        PrepareForLightingAndShading_id476();
    }
    float3 directLightingContribution = 0;

    {
        PrepareDirectLights_id259(streams);
        const int maxLightCount = GetMaxLightCount_id260(streams);
        int count = GetLightCount_id261(streams);

        for (int i = 0; i < maxLightCount; i++)
        {
            if (i >= count)
            {
                break;
            }
            PrepareDirectLight_id256(streams, i);
            PrepareMaterialPerDirectLight_id29(streams);

            {
                directLightingContribution += ComputeDirectLightContribution_id452(streams);
            }

            {
                directLightingContribution += ComputeDirectLightContribution_id508(streams);
            }
        }
    }

    {
        PrepareDirectLights_id267();
        const int maxLightCount = GetMaxLightCount_id272(streams);
        int count = GetLightCount_id273(streams);

        for (int i = 0; i < maxLightCount; i++)
        {
            if (i >= count)
            {
                break;
            }
            PrepareDirectLight_id269(streams, i);
            PrepareMaterialPerDirectLight_id29(streams);

            {
                directLightingContribution += ComputeDirectLightContribution_id452(streams);
            }

            {
                directLightingContribution += ComputeDirectLightContribution_id508(streams);
            }
        }
    }
    float3 environmentLightingContribution = 0;

    {
        PrepareEnvironmentLight_id298(streams);

        {
            environmentLightingContribution += ComputeEnvironmentLightContribution_id453(streams);
        }

        {
            environmentLightingContribution += ComputeEnvironmentLightContribution_id509(streams);
        }
    }

    {
        PrepareEnvironmentLight_id303(streams);

        {
            environmentLightingContribution += ComputeEnvironmentLightContribution_id453(streams);
        }

        {
            environmentLightingContribution += ComputeEnvironmentLightContribution_id509(streams);
        }
    }
    streams.shadingColor_id71 += directLightingContribution * PI_id243 + environmentLightingContribution;
    streams.shadingColorAlpha_id72 = streams.matDiffuse_id51.a;

    {
        AfterLightingAndShading_id460();
    }

    {
        AfterLightingAndShading_id479();
    }
}
void Compute_id569(inout PS_STREAMS streams)
{
    streams.matEmissiveIntensity_id61 = Compute_id326().r;
}
void Compute_id564(inout PS_STREAMS streams)
{
    streams.matEmissive_id60 = Compute_id324(streams).rgba;
}
void Compute_id559(inout PS_STREAMS streams)
{
    streams.matCavitySpecular_id59 = Compute_id322().r;
}
void Compute_id554(inout PS_STREAMS streams)
{
    streams.matCavityDiffuse_id58 = Compute_id320().r;
}
void Compute_id549(inout PS_STREAMS streams)
{
    streams.matCavity_id57 = Compute_id318().r;
}
void Compute_id544(inout PS_STREAMS streams)
{
    streams.matAmbientOcclusionDirectLightingFactor_id56 = Compute_id316().r;
}
void Compute_id539(inout PS_STREAMS streams)
{
    streams.matAmbientOcclusion_id55 = Compute_id314(streams).r;
}
void Compute_id534(inout PS_STREAMS streams)
{
    streams.matSpecularIntensity_id54 = Compute_id312().r;
}
void Compute_id529(inout PS_STREAMS streams)
{
    streams.matSpecular_id53 = Compute_id310().rgb;
}
void Compute_id524(inout PS_STREAMS streams)
{
    float glossiness = Compute_id308(streams).r;
    streams.matGlossiness_id52 = glossiness;
}
void Compute_id519(inout PS_STREAMS streams)
{
    float4 normal = Compute_id306(streams);

    {
        normal = (2.0f * normal) - 1.0f;
    }

    {
        normal.z = sqrt(max(0, 1.0f - (normal.x * normal.x + normal.y * normal.y)));
    }
    streams.matNormal_id49 = normal.xyz;
}
void Compute_id514(inout PS_STREAMS streams)
{
    float4 colorBase = Compute_id304(streams);
    streams.matDiffuse_id51 = colorBase;
    streams.matColorBase_id50 = colorBase;
}
void ResetStream_id248(inout PS_STREAMS streams)
{
    ResetStream_id247(streams);
    streams.matNormal_id49 = float3(0, 0, 1);
    streams.matColorBase_id50 = 0.0f;
    streams.matDiffuse_id51 = 0.0f;
    streams.matDiffuseVisible_id67 = 0.0f;
    streams.matSpecular_id53 = 0.0f;
    streams.matSpecularVisible_id69 = 0.0f;
    streams.matSpecularIntensity_id54 = 1.0f;
    streams.matGlossiness_id52 = 0.0f;
    streams.alphaRoughness_id68 = 1.0f;
    streams.matAmbientOcclusion_id55 = 1.0f;
    streams.matAmbientOcclusionDirectLightingFactor_id56 = 0.0f;
    streams.matCavity_id57 = 1.0f;
    streams.matCavityDiffuse_id58 = 0.0f;
    streams.matCavitySpecular_id59 = 0.0f;
    streams.matEmissive_id60 = 0.0f;
    streams.matEmissiveIntensity_id61 = 0.0f;
    streams.matScatteringStrength_id62 = 1.0f;
    streams.matDiffuseSpecularAlphaBlend_id63 = 1.0f;
    streams.matAlphaBlendColor_id64 = 1.0f;
    streams.matAlphaDiscard_id65 = 0.1f;
}
float FBM3D_id67(float3 inputCoordinates, float octaveCount, float lacunarity, float gain)
{
    float noiseSum = 0;
    float amplitude = 1;
    float amplitudeSum = 0;
    float3 sampleCoordinates = inputCoordinates;

    for (int i = 0; i < octaveCount; i++)
    {
        noiseSum += amplitude * SampleNoiseCoarse3D_id56(sampleCoordinates);
        amplitudeSum += amplitude;
        amplitude *= gain;
        sampleCoordinates *= lacunarity;
    }
    noiseSum /= amplitudeSum;
    return noiseSum;
}
float RandomValue_id48(float3 coordinates)
{
    return frac(sin(dot(coordinates.xyz, float3(12.9898, 78.233, 53.987))) * 43758.5453);
}
void Compute_id99(inout PS_STREAMS streams)
{

    {
        Compute_id514(streams);
    }

    {
        Compute_id519(streams);
    }

    {
        Compute_id524(streams);
    }

    {
        Compute_id529(streams);
    }

    {
        Compute_id534(streams);
    }

    {
        Compute_id539(streams);
    }

    {
        Compute_id544(streams);
    }

    {
        Compute_id549(streams);
    }

    {
        Compute_id554(streams);
    }

    {
        Compute_id559(streams);
    }

    {
        Compute_id564(streams);
    }

    {
        Compute_id569(streams);
    }

    {
        Compute_id585(streams);
    }

    {
        Compute_id586(streams);
    }
}
void ResetStream_id98(inout PS_STREAMS streams)
{
    ResetStream_id248(streams);
    streams.shadingColorAlpha_id72 = 1.0f;
}
float4 ComputeShadingPosition_id11(float4 world)
{
    return mul(world, ViewProjection_id28);
}
void PostTransformPosition_id6()
{
}
void PreTransformPosition_id4()
{
}
float4 ShowUnderConstruction_id80(float3 rawNoiseSamplePosition, float3 girderSamplePosition, float girderPerturbanceFactor)
{
    float internalColorLevel = 0.007;
    float randomNoise = RandomValue_id48(girderSamplePosition);
    float perturbanceNoise = FBM3D_id67(rawNoiseSamplePosition, 4, 2.0, 0.87);
    float3 offset = (perturbanceNoise * float3(1, 1, 1));
    rawNoiseSamplePosition += (girderPerturbanceFactor * 0.01 * offset);
    internalColorLevel += (0.0115 - (0.03 * randomNoise));
    internalColorLevel = saturate(internalColorLevel);
    float4 finalColor = float4(internalColorLevel, internalColorLevel, internalColorLevel, 1);
    if (abs(rawNoiseSamplePosition.x) % 0.006 < 0.0009 || abs(rawNoiseSamplePosition.y) % 0.006 < 0.0009 || abs(rawNoiseSamplePosition.z) % 0.006 < 0.00045)
    {
        float girderNoise = (0.02 * randomNoise);
        finalColor = float4(0.02 + girderNoise, 0.02 + girderNoise, 0.025 + girderNoise, 1);
    }
    return finalColor;
}
float Turbulence3D_id61(float3 inputCoordinates, float octaveCount, float lacunarity, float gain)
{
    float noiseSum = 0;
    float amplitude = 1;
    float amplitudeSum = 0;
    float3 sampleCoordinates = inputCoordinates;

    for (int i = 0; i < octaveCount; i++)
    {
        noiseSum += amplitude * abs(SampleNoiseCoarse3D_id56(sampleCoordinates));
        amplitudeSum += amplitude;
        amplitude *= gain;
        sampleCoordinates *= lacunarity;
    }
    noiseSum /= amplitudeSum;
    return noiseSum;
}
float4 Shading_id30(inout PS_STREAMS streams)
{
    streams.viewWS_id66 = normalize(Eye_id30.xyz - streams.PositionWS_id21.xyz);
    streams.shadingColor_id71 = 0;
    ResetStream_id98(streams);
    Compute_id99(streams);
    return float4(streams.shadingColor_id71, streams.shadingColorAlpha_id72);
}
float3x3 GetTangentWorldTransform_id22()
{
    return (float3x3)WorldInverseTranspose_id33;
}
float3x3 GetTangentMatrix_id15(inout PS_STREAMS streams)
{
    float3x3 tangentMatrix;
    streams.meshNormal_id15 = normalize(streams.meshNormal_id15);
    float3 tangent = normalize(streams.meshTangent_id17.xyz);
    float3 bitangent = streams.meshTangent_id17.w * cross(streams.meshNormal_id15, tangent);
    tangentMatrix = float3x3(tangent, bitangent, streams.meshNormal_id15);
    return tangentMatrix;
}
void PostTransformPosition_id12(inout VS_STREAMS streams)
{
    PostTransformPosition_id6();
    streams.ShadingPosition_id0 = ComputeShadingPosition_id11(streams.PositionWS_id21);
    streams.PositionH_id23 = streams.ShadingPosition_id0;
    streams.DepthVS_id22 = streams.ShadingPosition_id0.w;
}
void TransformPosition_id5()
{
}
void PreTransformPosition_id10(inout VS_STREAMS streams)
{
    PreTransformPosition_id4();
    streams.PositionWS_id21 = mul(streams.Position_id20, World_id31);
}
float4 Shading_id81(inout PS_STREAMS streams)
{
    float4 baseColor = Shading_id30(streams);
    float3 noiseSamplePosition = DW_NoiseOffset_id96 + (streams.Position_id20 * DW_NoiseScale_id97);
    float pixelDamageLevel = Turbulence3D_id61(noiseSamplePosition, 9, 2.0, 0.87);
    float fbmNoise = FBM3D_id67(noiseSamplePosition * 5.0, 9, 2.0, 0.83);
    pixelDamageLevel += (0.33 * fbmNoise);
    float damageThreshold = (0.32 - (DW_DamageLevel_id98 * 0.30));
    pixelDamageLevel = max(0, ((pixelDamageLevel - damageThreshold) * (1 / (1 - damageThreshold))));
    float fireThreshold = saturate(0.35 / (1 + (DW_DamageLevel_id98 * 0.003)));
    float4 finalColor = baseColor;
    if (DW_ConstructionLevel_id100 < 1)
    {
        float3 constructionNoiseSamplePosition = float3((round(noiseSamplePosition.x * 800) / 800), (round(noiseSamplePosition.y * 200) / 200), (round(noiseSamplePosition.z * 800) / 800));
        float constructionNoise = FBM3D_id67(constructionNoiseSamplePosition, 9, 2.0, 0.71);
        constructionNoise = ((constructionNoise + 1) / 2);
        float constructionThreshold = (DW_ConstructionLevel_id100 * 1);
        constructionThreshold = 0.47 + (constructionThreshold * 0.23);
        if (constructionNoise > constructionThreshold)
        {
            constructionNoiseSamplePosition = float3((round(noiseSamplePosition.x * 4000) / 4000), (round(noiseSamplePosition.y * 750) / 750), (round(noiseSamplePosition.z * 4000) / 4000));
            finalColor = ShowUnderConstruction_id80(noiseSamplePosition, constructionNoiseSamplePosition, 0);
        }
    }
    if (DW_DamageLevel_id98 > 0)
    {
        if (pixelDamageLevel > fireThreshold)
        {
            float fireDamage = max(0, ((pixelDamageLevel - fireThreshold) * (1 / (1 - fireThreshold))));
            float noiseOffset = ((DW_TimeValue_id101 % 13.0) / 13.0);
            float3 fireNoiseSamplePosition = ((streams.Position_id20 * 1.0) - float3(0, 0, noiseOffset));
            float fireNoise = FBM3D_id67(fireNoiseSamplePosition, 7, 2.0, 0.73);
            float3 fireColorLow = saturate(DW_NoiseColorLow_id102.rgb + (fireNoise * DW_NoiseColorLowAdd_id103.rgb));
            float3 fireColorHigh = saturate(DW_NoiseColorHigh_id104.rgb + (fireNoise * DW_NoiseColorHighAdd_id105.rgb));
            float3 constructionNoiseSamplePosition = float3((round(noiseSamplePosition.x * 800) / 800), (round(noiseSamplePosition.y * 200) / 200), (round(noiseSamplePosition.z * 800) / 800));
            float4 girderColor = ShowUnderConstruction_id80(noiseSamplePosition, constructionNoiseSamplePosition, 1);
            float3 fireColorLowFinal = lerp(fireColorLow, girderColor.rgb, 0.2);
            float3 fireColorHighFinal = lerp(fireColorHigh, girderColor.rgb, 1.0);
            float3 fireColor = lerp(fireColorLowFinal, fireColorHighFinal, fireDamage);
            finalColor = float4(fireColor, 1);
        }
        else
        {
            float3 blackenedHullColor = lerp(finalColor.rgb, float4(0, 0, 0, 1), saturate(pixelDamageLevel * 1.7 * (1 / fireThreshold)));
            finalColor = float4(blackenedHullColor, 1.0);
        }
    }
    return finalColor;
}
void PSMain_id1()
{
}
void UpdateTangentToWorld_id17(inout PS_STREAMS streams)
{
    float3x3 tangentMatrix = GetTangentMatrix_id15(streams);
    float3x3 tangentWorldTransform = GetTangentWorldTransform_id22();
    streams.tangentToWorld_id19 = mul(tangentMatrix, tangentWorldTransform);
}
void GenerateNormal_PS_id14()
{
}
void BaseTransformVS_id8(inout VS_STREAMS streams)
{
    PreTransformPosition_id10(streams);
    TransformPosition_id5();
    PostTransformPosition_id12(streams);
}
void VSMain_id0()
{
}
void PSMain_id3(inout PS_STREAMS streams)
{
    PSMain_id1();
    streams.ColorTarget_id2 = Shading_id81(streams);
}
void GenerateNormal_PS_id21(inout PS_STREAMS streams)
{
    GenerateNormal_PS_id14();
    UpdateTangentToWorld_id17(streams);
    streams.meshNormalWS_id16 = mul(streams.meshNormal_id15, (float3x3)WorldInverseTranspose_id33);
}
void GenerateNormal_VS_id13(inout VS_STREAMS streams)
{
    streams.normalWS_id18 = 0.0f;
}
void VSMain_id9(inout VS_STREAMS streams)
{
    VSMain_id0();
    BaseTransformVS_id8(streams);
}
void PSMain_id20(inout PS_STREAMS streams)
{
    GenerateNormal_PS_id21(streams);
    PSMain_id3(streams);
}
void VSMain_id19(inout VS_STREAMS streams)
{
    VSMain_id9(streams);
    GenerateNormal_VS_id13(streams);
}
PS_OUTPUT PSMain(PS_INPUT __input__)
{
    PS_STREAMS streams = (PS_STREAMS)0;
    streams.PositionWS_id21 = __input__.PositionWS_id21;
    streams.ShadingPosition_id0 = __input__.ShadingPosition_id0;
    streams.ScreenPosition_id108 = __input__.ScreenPosition_id108;
    streams.meshNormal_id15 = __input__.meshNormal_id15;
    streams.meshTangent_id17 = __input__.meshTangent_id17;
    streams.TexCoord_id177 = __input__.TexCoord_id177;
    streams.Position_id20 = __input__.Position_id20;
    streams.IsFrontFace_id1 = __input__.IsFrontFace_id1;
    streams.ScreenPosition_id108 /= streams.ScreenPosition_id108.w;
    PSMain_id20(streams);
    PS_OUTPUT __output__ = (PS_OUTPUT)0;
    __output__.ColorTarget_id2 = streams.ColorTarget_id2;
    return __output__;
}
VS_OUTPUT VSMain(VS_INPUT __input__)
{
    VS_STREAMS streams = (VS_STREAMS)0;
    streams.Position_id20 = __input__.Position_id20;
    streams.meshNormal_id15 = __input__.meshNormal_id15;
    streams.meshTangent_id17 = __input__.meshTangent_id17;
    streams.TexCoord_id177 = __input__.TexCoord_id177;
    VSMain_id19(streams);
    streams.ScreenPosition_id108 = streams.ShadingPosition_id0;
    VS_OUTPUT __output__ = (VS_OUTPUT)0;
    __output__.PositionWS_id21 = streams.PositionWS_id21;
    __output__.ShadingPosition_id0 = streams.ShadingPosition_id0;
    __output__.ScreenPosition_id108 = streams.ScreenPosition_id108;
    __output__.meshNormal_id15 = streams.meshNormal_id15;
    __output__.meshTangent_id17 = streams.meshTangent_id17;
    __output__.TexCoord_id177 = streams.TexCoord_id177;
    __output__.Position_id20 = streams.Position_id20;
    return __output__;
}
